//I2C address

 #define BMI160_I2C_ADDRESS                                                     0x68



 //Register and define



 #define CHIP_ID                                                                0xD1

 #define PMU_Status                                                             0x03

 #define ERR_reg                                                                0x02

  #define CMD                                                                   0x7E

 //Data registers



 #define  mag_x_lsb                                                             0x04

 #define  mag_x_msb                                                             0x05

 #define  mag_y_lsb                                                             0x06

 #define  mag_y_msb                                                             0x07

 #define  mag_z_lsb                                                             0x08

 #define  mag_z_msb                                                             0x09

 #define  rhall_lsb                                                             0x0A

 #define  rhall_msb                                                             0x0B

 #define  gyr_x_lsb                                                             0x0C

 #define  gyr_x_msb                                                             0x0D

 #define  gyr_y_lsb                                                             0x0E

 #define  gyr_y_msb                                                             0x0F

 #define  gyr_z_lsb                                                             0x10

 #define  gyr_z_msb                                                             0x11

 #define  acc_x_lsb                                                             0x12

 #define  acc_x_msb                                                             0x13

 #define  acc y_lsb                                                             0x14

 #define  acc_y_msb                                                             0x15

 #define  acc_z_lsb                                                             0x16

 #define  acc_z_msb                                                             0x17



 // CMD comands



 #define  accel_normal                                                          0x11

 #define  accel_low_power                                                       0x12

 #define  gyro_normal                                                           0x15

 #define  gyro_fast                                                             0x17