#line 1 "C:/Users/Viktor/Desktop/6dof_imu2/FT90/6dof_hw.c"
#line 1 "c:/users/viktor/desktop/new_compiler/mikroc pro for ft90x/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hal.h"
#line 1 "c:/users/viktor/desktop/new_compiler/mikroc pro for ft90x/include/stdint.h"
#line 73 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hal.h"
void dof6_hal_init( uint8_t address_id );
#line 85 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hal.h"
void dof6_hal_write( uint8_t *command,
 uint8_t *buffer,
 uint8_t count );
#line 98 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hal.h"
void dof6_hal_read( uint8_t *command,
 uint8_t *buffer,
 uint8_t count );
#line 1 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
#line 1 "c:/users/viktor/desktop/new_compiler/mikroc pro for ft90x/include/stdint.h"
#line 1 "c:/users/viktor/desktop/new_compiler/mikroc pro for ft90x/include/stdbool.h"



 typedef char _Bool;
#line 1 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hal.h"
#line 125 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
typedef enum
 {
 HZ_0_78,
 HZ_1_56,
 HZ_3_125,
 HZ_6_25,
 HZ_12_5,
 HZ_25,
 HZ_50,
 HZ_100,
 HZ_200,
 HZ_400,
 HZ_800,
 HZ_1600

} acc_output_data_rate ;

typedef enum
{
 G_2,
 G_4,
 G_8,
 G_16

}acc_g_range;

typedef enum
 {
 HZ_25_G,
 HZ_50_G,
 HZ_100_G,
 HZ_200_G,
 HZ_400_G,
 HZ_800_G,
 HZ_1600_G,
 HZ_3200_G

} gyr_output_data_rate ;

typedef enum
{
 ARR_2000,
 ARR_1000,
 ARR_500,
 ARR_250,
 ARR_120

}gyr_range;

typedef enum
 {
 M_HZ_0_78,
 M_HZ_1_56,
 M_HZ_3_125,
 M_HZ_6_25,
 M_HZ_12_5,
 M_HZ_25,
 M_HZ_50,
 M_HZ_100,
 M_HZ_200,
 M_HZ_400,
 M_HZ_800

} mag_output_data_rate ;

typedef enum
 {
 AF_HZ_1,
 AF_HZ_2,
 AF_HZ_4,
 AF_HZ_8,
 AF_HZ_16,
 AF_HZ_32,
 AF_HZ_64,
 AF_HZ_128
} acc_fifo_downsapling_ratio;

typedef enum
 {
 GF_HZ_1,
 GF_HZ_2,
 GF_HZ_4,
 GF_HZ_8,
 GF_HZ_16,
 GF_HZ_32,
 GF_HZ_64,
 GF_HZ_128
} gyr_fifo_downsapling_ratio;

typedef enum
 {
 NON_LATCHED,
 TEM_312_5_mis,
 TEM_625_mis,
 TEM_1_25_ms,
 TEM_2_5_ms,
 TEM_5_ms,
 TEM_10_ms,
 TEM_20_ms,
 TEM_40_ms,
 TEM_80_ms,
 TEM_160_ms,
 TEM_320_ms,
 TEM_640_ms,
 TEM_1_28_s,
 TEM_2_56_s,
 LATCHED

} int_latch_interrupt_modes ;

typedef enum
 {
 SKIP_TIME_1_5_s,
 SKIP_TIME_3_s,
 SKIP_TIME_6_s,
 SKIP_TIME_12_s

} int_sig_mot_skip ;

typedef enum
 {
 PROOF_TIME_0_25_s,
 PROOF_TIME_0_5_s,
 PROOF_TIME_1_s,
 PROOF_TIME_2_s

} int_sig_mot_proof;

typedef enum
 {
 SECOND_SHOCK_EVENT_50_s,
 SECOND_SHOCK_EVENT_100_s,
 SECOND_SHOCK_EVENT_150_s,
 SECOND_SHOCK_EVENT_200_s,
 SECOND_SHOCK_EVENT_250_s,
 SECOND_SHOCK_EVENT_375_s,
 SECOND_SHOCK_EVENT_500_s,
 SECOND_SHOCK_EVENT_700_s

} int_tap_dur;

typedef enum
 {
 SYMMETRICAL,
 HIGH_SYMMETRICAL,
 LOW_ASYMMETRICAL

} int_orient_mode ;

typedef enum
 {
 FLAT_STABLE_0_ms,
 FLAT_STABLE_640_ms,
 FLAT_STABLE_1280_ms,
 FLAT_STABLE_2560_ms
} int_flat_hold_time ;

typedef enum
 {
 X_DISABLED,
 X_1_g,
 X_minus_1_g,
 X_0_g
} foc_acc_x ;

typedef enum
 {
 Y_DISABLED,
 Y_1_g,
 Y_minus_1_g,
 Y_0_g
} foc_acc_y ;

typedef enum
 {
 Z_DISABLED,
 Z_1_g,
 Z_minus_1_g,
 Z_0_g
} foc_acc_z ;

typedef enum
{
 RD_1_BYTE,
 RD_2_BYTE,
 RD_6_BYTE,
 RD_8_BYTE

}mag_rd_burst;
#line 335 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
int8_t dof6_init ( uint8_t address );



int8_t dof6_get_chip_id();





int8_t dof6_fatal_error_detected();


uint8_t dof6_drop_cmd_err();
#line 355 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
int8_t dof6_error_detected();





int8_t dof6_acc_power_mode_status();


int8_t dof6_gyr_power_mode_status();


int8_t dof6_mag_power_mode_status();






int16_t dof6_get_mag_x();

int16_t dof6_get_mag_y();

int16_t dof6_get_mag_z();

int16_t dof6_get_rhall();

float dof6_get_gyr_x();

float dof6_get_gyr_y();

float dof6_get_gyr_z();

float dof6_get_acc_x();

float dof6_get_acc_y();

float dof6_get_acc_z();





float dof6_get_sensortime();





uint8_t dof6_data_ready_acc();

uint8_t dof6_data_ready_gyr();

uint8_t dof6_data_ready_mag();

uint8_t dof6_data_ready_nvm();

uint8_t dof6_data_ready_foc();
#line 416 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint8_t mag_man_op ();
#line 420 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint8_t gyr_self_test_ok ();






uint8_t dof6_get_step_int();

uint8_t dof6_get_sigmot_int();

uint8_t dof6_get_anym_int();

uint8_t dof6_get_pmu_trigger_int();

uint8_t dof6_get_d_tap_int();

uint8_t dof6_get_s_tap_int();

uint8_t dof6_get_orient_int();

uint8_t dof6_get_flat_int();






uint8_t dof6_get_highg_int();

uint8_t dof6_get_lowg_int();

uint8_t dof6_get_drdy_int();

uint8_t dof6_get_ffull_int();

uint8_t dof6_get_fwm_int();

uint8_t dof6_get_nomo_int();






uint8_t dof6_get_anym_first_x();

uint8_t dof6_get_anym_first_y();

uint8_t dof6_get_anym_first_z();

uint8_t dof6_get_anym_sign();

uint8_t dof6_get_tap_first_x();

uint8_t dof6_get_tap_first_y();

uint8_t dof6_get_tap_first_z();

uint8_t dof6_get_tap_sign();





uint8_t dof6_get_high_first_x();

uint8_t dof6_get_high_first_y();

uint8_t dof6_get_high_first_z();
#line 493 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint8_t dof6_get_high_sign();
#line 497 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint8_t dof6_get_orient();
#line 501 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint8_t dof6_get_orient_2();


uint8_t dof6_get_flat();





float dof6_get_sensor_temperature();





uint16_t dof6_get_fifo_lenght();






uint16_t dof6_get_fifo_data();





void dof6_set_acc_undersampling( _Bool  set);


uint8_t dof6_get_acc_undersampling();
#line 536 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint8_t dof6_get_acc_bandwidth() ;

int8_t dof6_set_acc_bandwidth(uint8_t bw);


float dof6_get_acc_output_data_rate();


void dof6_set_acc_output_data_rate(acc_output_data_rate acc_odr);
#line 551 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint8_t dof6_get_acc_g_range();
#line 555 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
void dof6_set_acc_g_range(acc_g_range acc_r);
#line 563 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint8_t dof6_get_gyr_bandwidth();

int8_t dof6_set_gyr_bandwidth(uint8_t bw);


float dof6_get_gyr_output_data_rate();


void dof6_set_gyr_output_data_rate(gyr_output_data_rate gyr_odr);
#line 579 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint32_t dof6_get_gyr_range();
#line 584 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
void dof6_set_gyr_range(gyr_range gyr_r);





uint8_t dof6_get_mag_output_data_rate();


void dof6_set_mag_output_data_rate(mag_output_data_rate mag_odr);







uint8_t dof6_get_acc_fifo_filt_data();

void dof6_set_acc_fifo_filt_data( _Bool  set);

uint16_t dof6_get_acc_fifo_downs ();

void dof6_set_acc_fifo_downs (acc_fifo_downsapling_ratio acc_fdr);

uint8_t dof6_get_gyr_fifo_filt_data();

void dof6_set_gyr_fifo_filt_data( _Bool  set);

uint16_t dof6_get_gyr_fifo_downs ();

void dof6_set_gyr_fifo_downs (gyr_fifo_downsapling_ratio gyr_fdr);
#line 624 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint8_t dof6_get_fifo_water_mark ();

uint8_t dof6_set_fifo_water_mark (uint8_t fifo_water_mark);





uint8_t dof6_get_fifo_gyr_en();

uint8_t dof6_get_fifo_acc_en() ;

uint8_t dof6_get_fifo_mag_en();


uint8_t dof6_get_fifo_header_en();


uint8_t dof6_get_fifo_tag_int1_en();

uint8_t dof6_get_fifo_tag_int2_en();
#line 648 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint8_t dof6_get_fifo_time_en();

void dof6_set_fifo_gyr_en( _Bool  set);

void dof6_set_fifo_acc_en( _Bool  set);

void dof6_set_fifo_mag_en( _Bool  set);

void dof6_set_fifo_header_en( _Bool  set);

void dof6_set_fifo_tag_int1_en( _Bool  set);

void dof6_set_fifo_tag_int2_en( _Bool  set);

void dof6_set_fifo_time_en( _Bool  set);






uint8_t dof6_get_mag_i2c_adress();

uint8_t dof6_set_mag_i2c_adress(uint8_t adr);





uint8_t dof6_get_mag_manual_en();

void dof6_set_mag_manual_en( _Bool  set);


uint8_t dof6_get_mag_offset();

void dof6_set_mag_offset(uint8_t offset);


uint8_t dof6_get_mag_rd_burst();

void dof6_set_mag_rd_burst(mag_rd_burst rd);





uint8_t dof6_get_mag_read_adress();

uint8_t dof6_set_mag_read_adress(uint8_t adr);





uint8_t dof6_get_mag_write_adress();

uint8_t dof6_set_mag_write_adress(uint8_t adr);





uint8_t dof6_get_mag_write_data();

uint8_t dof6_set_mag_write_adress(uint8_t adr);





uint8_t dof6_get_int_flat_en();

void dof6_set_int_flat_en( _Bool  set);

uint8_t dof6_get_int_orient_en();

void dof6_set_int_orient_en( _Bool  set);

uint8_t dof6_get_int_s_tap_en();

void dof6_set_int_s_tap_en( _Bool  set);

uint8_t dof6_get_int_d_tap_en();

void dof6_set_int_d_tap_en( _Bool  set);

uint8_t dof6_get_int_anymo_z_en();

void dof6_set_int_anymo_z_en( _Bool  set);

uint8_t dof6_get_int_anymo_y_en();

void dof6_set_int_anymo_y_en( _Bool  set);

uint8_t dof6_get_int_anymo_x_en();

void dof6_set_int_anymo_x_en( _Bool  set);





uint8_t dof6_get_int_fwm_en();

void dof6_set_int_fwm_en( _Bool  set);

uint8_t dof6_get_int_ffull_en();

void dof6_set_int_ffull_en( _Bool  set);

uint8_t dof6_get_int_drdy_en();

void dof6_set_int_drdy_en( _Bool  set);

uint8_t dof6_get_int_low_en();

void dof6_set_int_low_en( _Bool  set);

uint8_t dof6_get_int_highz_en();

void dof6_set_int_highz_en( _Bool  set);

uint8_t dof6_get_int_highy_en();

void dof6_set_int_highy_en( _Bool  set);

uint8_t dof6_get_int_highx_en();

void dof6_set_int_highx_en( _Bool  set);





uint8_t dof6_get_int_step_det_en();

void dof6_set_int_step_det_en( _Bool  set);

uint8_t dof6_get_int_nomoz_en();

void dof6_set_int_nomoz_en( _Bool  set);

uint8_t dof6_get_int_nomoy_en();

void dof6_set_int_nomoy_en( _Bool  set);

uint8_t dof6_get_int_nomox_en();

void dof6_set_int_nomox_en( _Bool  set);





uint8_t dof6_get_int2_output_en();

void dof6_set_int2_output_en( _Bool  set);


uint8_t dof6_get_int2_od();

void dof6_set_int2_od( _Bool  set);


uint8_t dof6_get_int2_lvl();

void dof6_set_int2_lvl( _Bool  set);


uint8_t dof6_get_int2_edge_crtl();

void dof6_set_int2_edge_crtl( _Bool  set);


uint8_t dof6_get_int1_output_en();

void dof6_set_int1_output_en( _Bool  set);


uint8_t dof6_get_int1_od();

void dof6_set_int1_od( _Bool  set);


uint8_t dof6_get_int1_lvl();

void dof6_set_int1_lvl( _Bool  set);


uint8_t dof6_get_int1_edge_crtl();

void dof6_set_int1_edge_crtl( _Bool  set);





uint8_t dof6_get_int2_input_en();

void dof6_set_int2_input_en( _Bool  set);


uint8_t dof6_get_int1_input_en();

void dof6_set_int1_input_en( _Bool  set);
#line 857 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
float dof6_get_int_latch();

void dof6_set_int_latch(int_latch_interrupt_modes int_latch);






uint8_t dof6_get_int1_flat();

void dof6_set_int1_flat( _Bool  set);

uint8_t dof6_get_int1_orient();

void dof6_set_int1_orient( _Bool  set);

uint8_t dof6_get_int1_s_tap();

void dof6_set_int1_s_tap( _Bool  set);

uint8_t dof6_get_int1_d_tap();

void dof6_set_int1_d_tap( _Bool  set);

uint8_t dof6_get_int1_nomotion();

void dof6_set_int1_nomotion( _Bool  set);

uint8_t dof6_get_int1_anymotion();

void dof6_set_int1_anymotion( _Bool  set);

uint8_t dof6_get_int1_highg();

void dof6_set_int1_highg( _Bool  set);

uint8_t dof6_get_int1_lowg_step();

void dof6_set_int1_lowg_step( _Bool  set);






uint8_t dof6_get_int1_drdy();

void dof6_set_int1_drdy( _Bool  set);

uint8_t dof6_get_int1_fwm();

void dof6_set_int1_fwm( _Bool  set);

uint8_t dof6_get_int1_ffull();

void dof6_set_int1_ffull( _Bool  set);

uint8_t dof6_get_int1_pmu_trig();

void dof6_set_int1_pmu_trig( _Bool  set);

uint8_t dof6_get_int2_drdy();

void dof6_set_int2_drdy( _Bool  set);

uint8_t dof6_get_int2_fwm();

void dof6_set_int2_fwm( _Bool  set);

uint8_t dof6_get_int2_ffull();

void dof6_set_int2_ffull( _Bool  set);

uint8_t dof6_get_int2_pmu_trig();

void dof6_set_int2_pmu_trig( _Bool  set);






uint8_t dof6_get_int2_flat();

void dof6_set_int2_flat( _Bool  set);

uint8_t dof6_get_int2_orient();

void dof6_set_int2_orient( _Bool  set);

uint8_t dof6_get_int2_s_tap();

void dof6_set_int2_s_tap( _Bool  set);

uint8_t dof6_get_int2_d_tap();

void dof6_set_int2_d_tap( _Bool  set);

uint8_t dof6_get_int2_nomotion();

void dof6_set_int2_nomotion( _Bool  set);

uint8_t dof6_get_int2_anymotion();

void dof6_set_int2_anymotion( _Bool  set);

uint8_t dof6_get_int2_highg();

void dof6_set_int2_highg( _Bool  set);

uint8_t dof6_get_int2_lowg_step();

void dof6_set_int2_lowg_step( _Bool  set);





uint8_t dof6_get_int_low_high_src();

void dof6_set_int_low_high_src( _Bool  set);


uint8_t dof6_get_int_tap_src();

void dof6_set_int_tap_src( _Bool  set);





uint8_t dof6_get_int_motion_src();

void dof6_set_int_motion_src( _Bool  set);






float dof6_get_int_low_dur();

uint8_t dof6_set_int_low_dur(float dur);
#line 1008 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
float dof6_get_int_low_th();

uint8_t dof6_set_int_low_th(float dur);
#line 1017 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
float dof6_get_int_high_hy();

uint8_t dof6_set_int_high_hy(float dur);


uint8_t dof6_get_int_low_mode();

void dof6_set_int_low_mode( _Bool  set);


float dof6_get_int_low_hy();

uint8_t dof6_set_int_low_hy(float dur);
#line 1037 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
float dof6_get_int_high_dur();

uint8_t dof6_set_int_high_dur(float dur);
#line 1048 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
float dof6_get_int_high_th();

uint8_t dof6_set_int_high_th(float dur);
#line 1064 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
float dof6_get_int_slo_nomo_dur();

int8_t dof6_set_int_slo_nomo_dur(float dur);
#line 1070 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint8_t dof6_get_int_anym_dur();

int8_t dof6_set_int_anym_dur(uint8_t dur);
#line 1081 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
float dof6_get_int_anymo_th();

uint8_t dof6_set_int_anymo_th(float th);
#line 1093 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
float dof6_get_int_slo_nomo_th();

uint8_t dof6_set_int_slo_nomo_th(float th);





uint8_t dof6_get_int_slo_nomo_sel();

void dof6_set_int_slo_nomo_sel( _Bool  set);


uint8_t dof6_get_int_sig_mot_sel();

void dof6_set_int_sig_mot_sel( _Bool  set);


float dof6_get_int_sig_mot_skip();

int8_t dof6_set_int_sig_mot_skip(int_sig_mot_skip time);


float dof6_get_int_sig_mot_proof();

int8_t dof6_set_int_sig_mot_proof(int_sig_mot_skip time);





uint8_t dof6_get_int_tap_quiet();

void dof6_set_int_tap_quiet( _Bool  set);


uint8_t dof6_get_int_tap_shock();

void dof6_set_int_tap_shock( _Bool  set);
#line 1136 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint16_t dof6_get_int_tap_dur();

int8_t dof6_set_int_tap_dur(int_tap_dur time);
#line 1147 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
float dof6_get_int_tap_th();

uint8_t dof6_set_int_tap_th(float th);
#line 1156 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
float dof6_get_int_orient_hy();

uint8_t dof6_set_int_orient_hy(float th);
#line 1164 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint8_t dof6_get_int_orient_blocking();

int8_t dof6_set_int_orient_blocking(uint8_t block);
#line 1170 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint8_t dof6_get_int_orient_mode();

int8_t dof6_set_int_orient_mode(int_orient_mode mode);





uint8_t dof6_get_int_orient_axes_ex();

void dof6_set_int_orient_axes_ex( _Bool  set);


uint8_t dof6_get_int_orient_ud_en();

void dof6_set_int_orient_ud_en( _Bool  set);


float dof6_get_int_orient_theta();

int8_t dof6_set_int_orient_theta(float orient);





float dof6_get_int_flat_theta();

int8_t dof6_set_int_flat_theta(float flat);
#line 1205 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint16_t dof6_get_int_flat_hold_time();

int8_t dof6_set_int_flat_hold_time(int_flat_hold_time time);


uint8_t dof6_get_int_flat_hy();

int8_t dof6_set_int_flat_hy(uint8_t flat_hy);





uint8_t dof6_get_foc_gyr_en();
#line 1222 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
void dof6_set_foc_gyr_en( _Bool  set);

int8_t dof6_get_foc_acc_x();

int8_t dof6_set_foc_acc_x(foc_acc_x offset);

int8_t dof6_get_foc_acc_y();

int8_t dof6_set_foc_acc_y(foc_acc_y offset);

int8_t dof6_get_foc_acc_z();

int8_t dof6_set_foc_acc_z(foc_acc_y offset);





uint8_t dof6_get_nvm_prog_en();

void dof6_set_nvm_prog_en( _Bool  set);





uint8_t dof6_get_spi3();

void dof6_set_spi3( _Bool  set);
#line 1257 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint8_t dof6_get_if_mode();

int8_t dof6_set_if_mode(uint8_t if_mode);





uint8_t dof6_get_wakeup_int();

void dof6_set_wakeup_int( _Bool  set);


uint8_t dof6_get_gyr_sleep_state();

void dof6_set_gyr_sleep_state( _Bool  set);

uint8_t dof6_get_gyr_wakeup_trigg();

int8_t dof6_set_gyr_wakeup_trigg(uint8_t gyr_wakeup);

uint8_t dof6_get_gyr_sleep_trigger();

int8_t dof6_set_gyr_sleep_trigger(uint8_t gyr_sleep);





uint8_t dof6_get_gyr_self_test_enable();

void dof6_set_gyr_self_test_enable( _Bool  set);


uint8_t dof6_get_acc_self_test_amp();

void dof6_set_acc_self_test_amp( _Bool  set);


uint8_t dof6_get_acc_self_test_sign();

void dof6_set_acc_self_test_sign( _Bool  set);


uint8_t dof6_get_acc_self_test_enable();

void dof6_set_acc_self_test_enable( _Bool  set);
#line 1310 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
uint8_t dof6_get_i2c_wdt_en();

void dof6_set_i2c_wdt_en( _Bool  set);


uint8_t dof6_get_i2c_wdt_sel();

void dof6_set_i2c_wdt_sel( _Bool  set);


uint8_t dof6_get_spi_en();

void dof6_set_spi_en( _Bool  set);
#line 1329 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
float dof6_get_off_acc_x();

uint8_t dof6_set_off_acc_x(float offset);




float dof6_get_off_acc_y();

uint8_t dof6_set_off_acc_y(float offset);




float dof6_get_off_acc_z();

uint8_t dof6_set_off_acc_z(float offset);
#line 1352 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hw.h"
float dof6_get_off_gyr_x();

uint8_t dof6_set_off_gyr_x(float offset);




float dof6_get_off_gyr_y();

uint8_t dof6_set_off_gyr_y(float offset);




float dof6_get_off_gyr_z();

uint8_t dof6_set_off_gyr_z(float offset);





uint8_t dof6_get_gyr_off_en();

void dof6_set_gyr_off_en( _Bool  set);

uint8_t dof6_get_acc_off_en();

void dof6_set_acc_off_en( _Bool  set);





uint16_t dof6_get_step_cnt();




uint8_t dof6_get_min_threshold();

int8_t dof6_set_min_threshold(uint8_t min_th);


uint8_t dof6_get_steptime_min();

int8_t dof6_set_steptime_min(uint8_t steptime);




uint8_t dof6_get_step_cnt_en();

void dof6_set_step_cnt_en( _Bool  set);


uint8_t dof6_get_min_step_buf();

int8_t dof6_set_min_step_buf(uint8_t steptime);






uint8_t dof6_get_cmd();

void dof6_set_cmd(uint8_t cmd);

void dof6_sensor_config (uint8_t accel_state, uint8_t gyro_state);
#line 28 "C:/Users/Viktor/Desktop/6dof_imu2/FT90/6dof_hw.c"
static inline uint8_t get_bit (uint8_t reg_num, uint8_t bit_num)
{
 uint8_t temp = 0;
 dof6_hal_read(&reg_num, &temp, 1);
 temp = temp >> bit_num;
 temp &= 1;
 return temp;
}

static inline clear_bit (uint8_t reg_num, uint8_t bit_num)
{
 uint8_t temp = 0;

 dof6_hal_read(&reg_num, &temp, 1);
 temp &= ~(1 << bit_num);
 dof6_hal_write(&reg_num, &temp, 1);
}

static inline set_bit (uint8_t reg_num, uint8_t bit_num)
{
 uint8_t temp = 0;

 dof6_hal_read(&reg_num, &temp, 1);
 temp |= (1 << bit_num);
 dof6_hal_write(&reg_num, &temp, 1);
}


static inline int16_t get_data(uint8_t adress)
{


 int16_t temp = 0;
 int16_t tempdata = 0;
 uint8_t buffer[2];
 dof6_hal_read(&adress , buffer, 2);
 temp |= (int16_t)buffer[0];
 temp |= ((int16_t)buffer[1]) << 8;

 return temp;

}

static inline uint16_t get_unsinged_data(uint8_t adress)
{


 uint16_t temp = 0;
 uint8_t buffer[2];
 dof6_hal_read(&adress , buffer, 2);

 temp += (int16_t) buffer[0];

 temp |= ((int16_t) buffer[1]) << 8;


 return temp;

}
#line 94 "C:/Users/Viktor/Desktop/6dof_imu2/FT90/6dof_hw.c"
int8_t dof6_init ( uint8_t address )
{
 uint8_t adress = 0x1B;
 uint8_t temp;
 dof6_hal_init ( address );


 dof6_hal_read(&adress, &temp, 1);
 if (temp != 0x01) return -1;

 return 0;
}



int8_t dof6_get_chip_id()
{
 uint8_t adress =  0x00 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 return temp;
}



int8_t dof6_fatal_error_detected()
{
 return get_bit( 0x02 , 0);
}

uint8_t dof6_drop_cmd_err() {
 return get_bit( 0x02 , 6);


}

int8_t dof6_error_detected() {
 uint8_t adress =  0x02 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 if (((temp >> 1) & 0x0F) == 0) return 0;
 else if (((temp >> 1) & 0x0F) == 1) return 1;
 else if (((temp >> 1) & 0x0F) == 2) return 2;
 else if (((temp >> 1) & 0x0F) == 3) return 3;
 else if (((temp >> 1) & 0x0F) == 6) return 4;
 else if (((temp >> 1) & 0x0F) == 7) return 5;
 else return -1;
}



int8_t dof6_acc_power_mode_status()
{
 uint8_t adress =  0x03 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 4;
 temp &= 3;
 if (temp == 1) return 0;
 if (temp == 0) return -1;
 if (temp == 2) return 1;
 return 0;
}

int8_t dof6_gyr_power_mode_status()
{
 uint8_t adress =  0x03 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 2;
 temp &= 3;
 if (temp == 1) return 0;
 if (temp == 0) return -1;
 if (temp == 2) return 1;
 if (temp == 3) return 2;
}


int8_t dof6_mag_power_mode_status()
{
 uint8_t adress =  0x03 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 3;
 if (temp == 1) return 0;
 if (temp == 0) return -1;
 if (temp == 2) return 1;
 return 0;
}



int16_t dof6_get_mag_x()
{
 return get_data( 0x04 );
}

int16_t dof6_get_mag_y()
{
 return get_data( 0x06 );
}

int16_t dof6_get_mag_z()
{
 return get_data( 0x08 );
}

int16_t dof6_get_rhall()
{
 return get_data( 0x0A );
}

float dof6_get_gyr_x()
{
 int16_t temp_data;
 float temp;
 temp_data = get_data( 0x0C );
 if (dof6_get_gyr_range() == 125)
 {
 temp = temp_data / 262.4;
 return temp;
 }
 if (dof6_get_gyr_range() == 250)
 {
 temp = temp_data / 131.2;
 return temp;
 }
 if (dof6_get_gyr_range() == 500)
 {
 temp = temp_data / 65.6;
 return temp;
 }
 if (dof6_get_gyr_range() == 1000)
 {
 temp = temp_data / 32.8;
 return temp;
 }
 if (dof6_get_gyr_range() == 2000)
 {
 temp = temp_data / 16.4;
 return temp;
 }
}

float dof6_get_gyr_y()
{
 int16_t temp_data;
 float temp;
 temp_data = get_data( 0x0E );
 if (dof6_get_gyr_range() == 125)
 {
 temp = temp_data / 262.4;
 return temp;
 }
 if (dof6_get_gyr_range() == 250)
 {
 temp = temp_data / 131.2;
 return temp;
 }
 if (dof6_get_gyr_range() == 500)
 {
 temp = temp_data / 65.6;
 return temp;
 }
 if (dof6_get_gyr_range() == 1000)
 {
 temp = temp_data / 32.8;
 return temp;
 }
 if (dof6_get_gyr_range() == 2000)
 {
 temp = temp_data / 16.4;
 return temp;
 }
}

float dof6_get_gyr_z()
{
 int16_t temp_data;
 float temp;
 temp_data = get_data( 0x10 );
 if (dof6_get_gyr_range() == 125)
 {
 temp = temp_data / 262.4;
 return temp;
 }
 if (dof6_get_gyr_range() == 250)
 {
 temp = temp_data / 131.2;
 return temp;
 }
 if (dof6_get_gyr_range() == 500)
 {
 temp = temp_data / 65.6;
 return temp;
 }
 if (dof6_get_gyr_range() == 1000)
 {
 temp = temp_data / 32.8;
 return temp;
 }
 if (dof6_get_gyr_range() == 2000)
 {
 temp = temp_data / 16.4;
 return temp;
 }
}

float dof6_get_acc_x()
{
 int16_t temp_data;
 float temp;
 temp_data = get_data( 0x12 );
 if (dof6_get_acc_g_range() == 2)
 {
 temp = (float)temp_data / 16368;
 return temp;
 }
 if (dof6_get_acc_g_range() == 4)
 {
 temp = (float)temp_data / 8192;
 return temp;
 }
 if (dof6_get_acc_g_range() == 8)
 {
 temp = (float)temp_data / 4096;
 return temp;
 }
 if (dof6_get_acc_g_range() == 16)
 {
 temp = (float)temp_data / 2048;
 return temp;
 }
}

float dof6_get_acc_y()
{
 int16_t temp_data;
 float temp;
 temp_data = get_data( 0x14 );
 if (dof6_get_acc_g_range() == 2)
 {
 temp = (float)temp_data / 16368;
 return temp;
 }
 if (dof6_get_acc_g_range() == 4)
 {
 temp = (float)temp_data / 8192;
 return temp;
 }
 if (dof6_get_acc_g_range() == 8)
 {
 temp = (float)temp_data / 4096;
 return temp;
 }
 if (dof6_get_acc_g_range() == 16)
 {
 temp = (float)temp_data / 2048;
 return temp;
 }
}
float dof6_get_acc_z()
{
 int16_t temp_data;
 float temp;
 temp_data = get_data( 0x16 );
 if (dof6_get_acc_g_range() == 2)
 {
 temp = (float)temp_data / 16368;
 return temp;
 }
 if (dof6_get_acc_g_range() == 4)
 {
 temp = (float)temp_data / 8192;
 return temp;
 }
 if (dof6_get_acc_g_range() == 8)
 {
 temp = (float)temp_data / 4096;
 return temp;
 }
 if (dof6_get_acc_g_range() == 16)
 {
 temp = (float)temp_data / 2048;
 return temp;
 }
}



float dof6_get_sensortime()
{
 uint8_t adress =  0x18 ;
 uint32_t temp = 0;
 float t = 0;
 uint8_t buffer[3];
 dof6_hal_read(&adress, buffer, 3);
 temp += (uint32_t) buffer[0];
 temp |= ((uint16_t) buffer[1]) << 8;
 temp |= ((uint16_t) buffer[2]) << 16;
 t = temp * 0.039;
 return t;
}



uint8_t dof6_data_ready_acc()
{
 return get_bit( 0x1B , 7);

}


uint8_t dof6_data_ready_gyr()
{
 return get_bit( 0x1B , 6);

}
uint8_t dof6_data_ready_mag()
{
 return get_bit( 0x1B , 5);

}
uint8_t dof6_data_ready_nvm()
{
 return get_bit( 0x1B , 4);

}

uint8_t dof6_data_ready_foc()
{
 return get_bit( 0x1B , 3);

}

uint8_t mag_man_op ()
{
 return get_bit( 0x1B , 2);

}

uint8_t gyr_self_test_ok () {
 return get_bit( 0x1B , 1);
}



uint8_t dof6_get_step_int()
{
 return get_bit( 0x1C , 0);
}

uint8_t dof6_get_sigmot_int()
{
 return get_bit( 0x1C , 1);
}

uint8_t dof6_get_anym_int()
{
 return get_bit( 0x1C , 2);
}

uint8_t dof6_get_pmu_trigger_int()
{
 return get_bit( 0x1C , 3);
}

uint8_t dof6_get_d_tap_int()
{
 return get_bit( 0x1C , 4);
}

uint8_t dof6_get_s_tap_int()
{
 return get_bit( 0x1C , 5);
}

uint8_t dof6_get_orient_int()
{
 return get_bit( 0x1C , 6);
}

uint8_t dof6_get_flat_int()
{
 return get_bit( 0x1C , 7);
}



uint8_t dof6_get_highg_int()
{
 return get_bit( 0x1D , 2);
}

uint8_t dof6_get_lowg_int()
{
 return get_bit( 0x1D , 3);
}

uint8_t dof6_get_drdy_int()
{
 return get_bit( 0x1D , 4);
}

uint8_t dof6_get_ffull_int()
{
 return get_bit( 0x1D , 5);
}

uint8_t dof6_get_fwm_int()
{
 return get_bit( 0x1D , 6);
}

uint8_t dof6_get_nomo_int()
{
 return get_bit( 0x1D , 7);
}



uint8_t dof6_get_anym_first_x()
{
 return get_bit( 0x1E , 0);
}

uint8_t dof6_get_anym_first_y()
{
 return get_bit( 0x1E , 1);
}

uint8_t dof6_get_anym_first_z()
{
 return get_bit( 0x1E , 2);
}

uint8_t dof6_get_anym_sign()
{
 return get_bit( 0x1E , 3);
}

uint8_t dof6_get_tap_first_x()
{
 return get_bit( 0x1E , 4);
}

uint8_t dof6_get_tap_first_y()
{
 return get_bit( 0x1E , 5);
}

uint8_t dof6_get_tap_first_z()
{
 return get_bit( 0x1E , 6);
}

uint8_t dof6_get_tap_sign()
{
 return get_bit( 0x1E , 7);
}



uint8_t dof6_get_high_first_x()
{
 return get_bit( 0x1F , 0);
}

uint8_t dof6_get_high_first_y()
{
 return get_bit( 0x1F , 1);
}

uint8_t dof6_get_high_first_z()
{
 return get_bit( 0x1F , 2);
}

uint8_t dof6_get_high_sign()
{
 return get_bit( 0x1F , 3);
}

uint8_t dof6_get_orient()
{
 uint8_t adress =  0x1F ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 4;
 temp &= 3;
 return temp;
}


uint8_t dof6_get_orient_2()
{
 return get_bit( 0x1F , 6);
}

uint8_t dof6_get_flat()
{
 return get_bit( 0x1F , 7);
}



float dof6_get_sensor_temperature()
{
 float t = 0;
 uint16_t temp = 0;
 temp = get_unsinged_data( 0x20 );
 if (temp >> 15 == 1)
 {
 temp = ~(temp) + 1;
 t = 23 - temp / pow(2, 9);
 return t;
 }
 t = 23 + temp / pow(2, 9);
 return t;
}



uint16_t dof6_get_fifo_lenght()
{
 uint8_t adress =  0x22 ;
 uint16_t temp = 0;
 uint8_t buffer[2];
 dof6_hal_read(&adress, buffer, 2);
 temp += (uint16_t) buffer[0];
 buffer[1] = buffer[1] & 0x07;
 temp |= ((uint16_t) buffer[1]) << 8;
 return temp;
}



uint16_t dof6_get_fifo_data()
{
 uint8_t adress =  0x24 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 return temp;

}



void dof6_set_acc_undersampling( _Bool  set)
{
 if (set) set_bit( 0x40 , 7);
 else clear_bit ( 0x40 , 7);
}

uint8_t dof6_get_acc_undersampling()
{
 return get_bit( 0x40 , 7);
}

uint8_t dof6_get_acc_bandwidth()
{
 uint8_t adress =  0x40 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x70;
 temp = temp >> 4;
 return temp;

}

int8_t dof6_set_acc_bandwidth(uint8_t bw)
{
 uint8_t status = 0;
 uint8_t adress =  0x40 ;
 uint8_t temp;
 if (bw < 0 || bw > 7) return status = -1;
 bw = bw << 4;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x70);
 temp |= bw;
 dof6_hal_write(&adress, &temp, 1);
 return status;

}

float dof6_get_acc_output_data_rate()
{
 uint8_t adress =  0x40 ;
 uint8_t temp;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x0F;
 t = 100 / (pow(2, 8 - temp));
 return t;
}

void dof6_set_acc_output_data_rate(acc_output_data_rate acc_odr)
{
 uint8_t adress =  0x40 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 switch (acc_odr)
 {
 case HZ_0_78:
 temp &= ~(15);
 temp |= 1;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_1_56:
 temp &= ~(15);
 temp |= 2;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_3_125:
 temp &= ~(15);
 temp |= 3;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_6_25:
 temp &= ~(15);
 temp |= 4;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_12_5:
 temp &= ~(15);
 temp |= 5;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_25:
 temp &= ~(15);
 temp |= 6;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_50:
 temp &= ~(15);
 temp |= 7;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_100:
 temp &= ~(15);
 temp |= 8;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_200:
 temp &= ~(15);
 temp |= 9;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_400:
 temp &= ~(15);
 temp |= 10;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_800:
 temp &= ~(15);
 temp |= 11;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_1600:
 temp &= ~(15);
 temp |= 12;
 dof6_hal_write(&adress, &temp, 1);
 break;
 }
}



uint8_t dof6_get_acc_g_range()
{
 uint8_t adress =  0x41 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x0F;
 if (temp == 3) return 2;
 if (temp == 5) return 4;
 if (temp == 8) return 8;
 if (temp == 12) return 16;
 return 2;
}

void dof6_set_acc_g_range(acc_g_range acc_r)
{
 uint8_t adress =  0x41 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 switch (acc_r)
 {
 case G_2:
 temp &= ~(15);
 temp |= 3;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case G_4:
 temp &= ~(15);
 temp |= 5;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case G_8:
 temp &= ~(15);
 temp |= 8;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case G_16:
 temp &= ~(15);
 temp |= 12;
 dof6_hal_write(&adress, &temp, 1);
 break;
 }
}



uint8_t dof6_get_gyr_bandwidth()
{
 uint8_t adress =  0x42 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x30;
 temp = temp >> 4;
 return temp;

}


int8_t dof6_set_gyr_bandwidth(uint8_t bw)
{
 uint8_t status = 0;
 uint8_t temp;
 uint8_t adress =  0x42 ;
 if (bw < 0 || bw > 3) return status = -1;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x30);
 bw = bw << 4;
 temp |= bw;
 dof6_hal_write(&adress, &temp, 1);
 return status;

}


float dof6_get_gyr_output_data_rate()
{
 uint8_t adress =  0x42 ;
 uint8_t temp;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x0F;
 t = 100 / pow(2, 8 - temp);
 return t;
}

void dof6_set_gyr_output_data_rate(gyr_output_data_rate gyr_odr)
{
 uint8_t adress =  0x42 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 switch (gyr_odr)
 {

 case HZ_25_G:
 temp &= ~(15);
 temp |= 6;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_50_G:
 temp &= ~(15);
 temp |= 7;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_100_G:
 temp &= ~(15);
 temp |= 8;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_200_G:
 temp &= ~(15);
 temp |= 9;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_400_G:
 temp &= ~(15);
 temp |= 10;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_800_G:
 temp &= ~(15);
 temp |= 11;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_1600_G:
 temp &= ~(15);
 temp |= 12;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HZ_3200_G:
 temp &= ~(15);
 temp |= 13;
 dof6_hal_write(&adress, &temp, 1);
 break;
 }
}



uint32_t dof6_get_gyr_range()
{
 uint8_t adress =  0x43 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x07;
 if (temp == 0) return 2000;
 if (temp == 1) return 1000;
 if (temp == 2) return 500;
 if (temp == 3) return 250;
 if (temp == 4) return 125;
 return -1;

}

void dof6_set_gyr_range(gyr_range gyr_r)
{
 uint8_t adress =  0x43 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 switch (gyr_r)
 {
 case ARR_2000:
 temp &= ~(7);
 temp |= 0;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case ARR_1000:
 temp &= ~(7);
 temp |= 1;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case ARR_500:
 temp &= ~(7);
 temp |= 2;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case ARR_250:
 temp &= ~(7);
 temp |= 3;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case ARR_120:
 temp &= ~(7);
 temp |= 4;
 dof6_hal_write(&adress, &temp, 1);
 break;
 }
}



uint8_t dof6_get_mag_output_data_rate()
{
 uint8_t adress =  0x44 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x0F;
 return temp;
}

void dof6_set_mag_output_data_rate(mag_output_data_rate mag_odr)
{
 uint8_t adress =  0x44 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 switch (mag_odr)
 {

 case M_HZ_0_78:
 temp &= ~(15);
 temp |= 1;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case M_HZ_1_56:
 temp &= ~(15);
 temp |= 2;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case M_HZ_3_125:
 temp &= ~(15);
 temp |= 3;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case M_HZ_6_25:
 temp &= ~(15);
 temp |= 4;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case M_HZ_12_5:
 temp &= ~(15);
 temp |= 5;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case M_HZ_25:
 temp &= ~(15);
 temp |= 6;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case M_HZ_50:
 temp &= ~(15);
 temp |= 7;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case M_HZ_100:
 temp &= ~(15);
 temp |= 8;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case M_HZ_200:
 temp &= ~(15);
 temp |= 9;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case M_HZ_400:
 temp &= ~(15);
 temp |= 10;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case M_HZ_800:
 temp &= ~(15);
 temp |= 11;
 dof6_hal_write(&adress, &temp, 1);
 break;
 }
}




uint8_t dof6_get_acc_fifo_filt_data()
{
 return get_bit( 0x45 , 7);
}

void dof6_set_acc_fifo_filt_data( _Bool  set)
{
 if (set) set_bit( 0x45 , 7);
 else clear_bit ( 0x45 , 7);
}

uint16_t dof6_get_acc_fifo_downs ()
{
 uint16_t t;
 uint8_t adress =  0x45 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x70;
 temp = temp >> 4;
 t = pow(2, temp);
 return t;
}

void dof6_set_acc_fifo_downs (acc_fifo_downsapling_ratio acc_fdr)
{
 uint8_t adress =  0x45 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x70);
 switch (acc_fdr)
 {
 case AF_HZ_1:
 dof6_hal_write(&adress, &temp, 1);
 break;
 case AF_HZ_2:
 temp |= (1 << 4);
 dof6_hal_write(&adress, &temp, 1);
 break;
 case AF_HZ_4:
 temp |= (2 << 4);
 dof6_hal_write(&adress, &temp, 1);
 break;
 case AF_HZ_8:
 temp |= (3 << 4);
 dof6_hal_write(&adress, &temp, 1);
 break;
 case AF_HZ_16:
 temp |= (4 << 4);
 dof6_hal_write(&adress, &temp, 1);
 break;
 case AF_HZ_32:
 temp |= (5 << 4);
 dof6_hal_write(&adress, &temp, 1);
 break;
 case AF_HZ_64:
 temp |= (6 << 4) ;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case AF_HZ_128:
 temp |= (7 << 4) ;
 dof6_hal_write(&adress, &temp, 1);
 break;
 }
}

uint8_t dof6_get_gyr_fifo_filt_data()
{
 return get_bit( 0x45 , 3);
}
void dof6_set_gyr_fifo_filt_data( _Bool  set)
{
 if (set) set_bit( 0x45 , 0);
 else clear_bit ( 0x45 , 0);
}

uint16_t dof6_get_gyr_fifo_downs ()
{
 uint16_t t;
 uint8_t adress =  0x45 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x07;
 t = pow(2, temp);
 return t;
}

void dof6_set_gyr_fifo_downs (gyr_fifo_downsapling_ratio gyr_fdr)
{
 uint8_t adress =  0x45 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(7);
 switch (gyr_fdr)
 {
 case GF_HZ_1:
 temp |= 0;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case GF_HZ_2:
 temp |= 1;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case GF_HZ_4:
 temp |= 2;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case GF_HZ_8:
 temp |= 3;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case GF_HZ_16:
 temp |= 4;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case GF_HZ_32:
 temp |= 5;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case GF_HZ_64:
 temp |= 6;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case GF_HZ_128:
 temp |= 7;
 dof6_hal_write(&adress, &temp, 1);
 break;
 }
}



uint8_t dof6_get_fifo_water_mark ()
{
 uint8_t adress =  0x46 ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 return temp;
}

uint8_t dof6_set_fifo_water_mark (uint8_t fifo_water_mark)
{
 uint8_t status = 0;
 uint8_t adress =  0x46 ;
 uint8_t temp = fifo_water_mark;
 if (fifo_water_mark > 255) return status - 1;
 dof6_hal_write(&adress, &temp, 1);

}



uint8_t dof6_get_fifo_gyr_en()
{
 return get_bit( 0x47 , 7);
}

uint8_t dof6_get_fifo_acc_en()
{
 return get_bit( 0x47 , 6);
}

uint8_t dof6_get_fifo_mag_en()
{
 return get_bit( 0x47 , 5);
}

uint8_t dof6_get_fifo_header_en()
{
 return get_bit( 0x47 , 4);
}

uint8_t dof6_get_fifo_tag_int1_en()
{
 return get_bit( 0x47 , 3);
}

uint8_t dof6_get_fifo_tag_int2_en()
{
 return get_bit( 0x47 , 2);
}

uint8_t dof6_get_fifo_time_en()
{
 return get_bit( 0x47 , 1);
}


void dof6_set_fifo_gyr_en( _Bool  set)
{
 if (set) set_bit( 0x47 , 7);
 else clear_bit ( 0x47 , 7);
}

void dof6_set_fifo_acc_en( _Bool  set)
{
 if (set) set_bit( 0x47 , 6);
 else clear_bit ( 0x47 , 6);
}

void dof6_set_fifo_mag_en( _Bool  set)
{
 if (set) set_bit( 0x47 , 5);
 else clear_bit ( 0x47 , 5);
}

void dof6_set_fifo_header_en( _Bool  set)
{
 if (set) set_bit( 0x47 , 4);
 else clear_bit ( 0x47 , 4);
}

void dof6_set_fifo_tag_int1_en( _Bool  set)
{
 if (set) set_bit( 0x47 , 3);
 else clear_bit ( 0x47 , 3);
}

void dof6_set_fifo_tag_int2_en( _Bool  set)
{
 if (set) set_bit( 0x47 , 2);
 else clear_bit ( 0x47 , 2);
}
void dof6_set_fifo_time_en( _Bool  set)
{
 if (set) set_bit( 0x47 , 1);
 else clear_bit ( 0x47 , 1);
}



uint8_t dof6_get_mag_i2c_adress()
{
 uint8_t adress =  0x4B ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 1;
 temp &= 0x7F;
 return temp;
}

uint8_t dof6_set_mag_i2c_adress(uint8_t adr)
{
 uint8_t status = 0;
 uint8_t temp;
 uint8_t adress =  0x4B ;
 if ( adr > 0x7F ) return status = -1;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0xFE);
 temp |= (adr << 1);
 dof6_hal_write(&adress, &temp, 1);
 return status;
}



uint8_t dof6_get_mag_manual_en()
{
 return get_bit( 0x4C , 7);
}

void dof6_set_mag_manual_en( _Bool  set)
{
 if (set) set_bit( 0x4C , 1);
 else clear_bit ( 0x4C , 1);
}

uint8_t dof6_get_mag_offset()
{
 uint8_t adress =  0x4C ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 2;
 temp &= 0x0F;
 return temp;
}

void dof6_set_mag_offset(uint8_t offset)
{
 uint8_t temp;
 uint8_t adress =  0x4C ;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x3C);
 temp |= (offset << 2);
 dof6_hal_write(&adress, &temp, 1);

}

uint8_t dof6_get_mag_rd_burst()
{
 uint8_t adress =  0x4C ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x03;
 if (temp == 0) return 1;
 if (temp == 1) return 2;
 if (temp == 2) return 6;
 if (temp == 3) return 8;
}

void dof6_set_mag_rd_burst(mag_rd_burst rd)
{
 uint8_t adress =  0x4C ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x03);
 switch (rd)
 {
 case RD_1_BYTE:
 dof6_hal_write(&adress, &temp, 1);
 break;
 case RD_2_BYTE:
 temp |= 1;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case RD_6_BYTE:
 temp |= 2;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case RD_8_BYTE:
 temp |= 3;
 dof6_hal_write(&adress, &temp, 1);
 break;
 }
}



uint8_t dof6_get_mag_read_adress()
{
 uint8_t adress =  0x4D ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 return temp;
}

uint8_t dof6_set_mag_read_adress(uint8_t adr)
{
 uint8_t status = 0;
 uint8_t adress =  0x4D ;
 if (adr > 255) return status = -1;
 dof6_hal_write(&adress, &adr, 1);
 return status = 0;
}



uint8_t dof6_get_mag_write_adress()
{
 uint8_t adress =  0x4E ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 return temp;
}

uint8_t dof6_set_mag_write_adress(uint8_t adr)
{
 uint8_t status = 0;
 uint8_t adress =  0x4E ;
 if (adr > 255) return status = -1;
 dof6_hal_write(&adress, &adr, 1);
 return status;
}



uint8_t dof6_get_mag_write_data()
{
 uint8_t adress =  0x4F ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 return temp;
}

uint8_t dof6_set_mag_write_data(uint8_t adr)
{
 uint8_t status = 0;
 uint8_t adress =  0x4F ;
 if (adr > 255) return status = -1;
 dof6_hal_write(&adress, &adr, 1);
 return status;
}



uint8_t dof6_get_int_flat_en()
{
 return get_bit(  0x50 , 7);
}


void dof6_set_int_flat_en( _Bool  set)
{
 if (set) set_bit( 0x50 , 7);
 else clear_bit ( 0x50 , 7);
}

uint8_t dof6_get_int_orient_en()
{
 return get_bit(  0x50 , 6);
}


void dof6_set_int_orient_en( _Bool  set)
{
 if (set) set_bit( 0x50 , 6);
 else clear_bit ( 0x50 , 6);
}

uint8_t dof6_get_int_s_tap_en()
{
 return get_bit(  0x50 , 5);
}


void dof6_set_int_s_tap_en( _Bool  set)
{
 if (set) set_bit( 0x50 , 5);
 else clear_bit ( 0x50 , 5);
}

uint8_t dof6_get_int_d_tap_en()
{
 return get_bit(  0x50 , 4);
}


void dof6_set_int_d_tap_en( _Bool  set)
{
 if (set) set_bit( 0x50 , 4);
 else clear_bit ( 0x50 , 4);
}

uint8_t dof6_get_int_anymo_z_en()
{
 return get_bit(  0x50 , 2);
}


void dof6_set_int_anymo_z_en( _Bool  set)
{
 if (set) set_bit( 0x50 , 2);
 else clear_bit ( 0x50 , 2);
}

uint8_t dof6_get_int_anymo_y_en()
{
 return get_bit(  0x50 , 1);
}


void dof6_set_int_anymo_y_en( _Bool  set)
{
 if (set) set_bit( 0x50 , 1);
 else clear_bit ( 0x50 , 1);
}


uint8_t dof6_get_int_anymo_x_en()
{
 return get_bit(  0x50 , 0);
}


void dof6_set_int_anymo_x_en( _Bool  set)
{
 if (set) set_bit( 0x50 , 0);
 else clear_bit ( 0x50 , 0);
}



uint8_t dof6_get_int_fwm_en()
{
 return get_bit(  0x51 , 6);
}


void dof6_set_int_fwm_en( _Bool  set)
{
 if (set) set_bit( 0x51 , 6);
 else clear_bit ( 0x51 , 6);
}

uint8_t dof6_get_int_ffull_en()
{
 return get_bit(  0x51 , 5);
}


void dof6_set_int_ffull_en( _Bool  set)
{
 if (set) set_bit( 0x51 , 5);
 else clear_bit ( 0x51 , 5);
}

uint8_t dof6_get_int_drdy_en()
{
 return get_bit(  0x51 , 4);
}


void dof6_set_int_drdy_en( _Bool  set)
{
 if (set) set_bit( 0x51 , 4);
 else clear_bit ( 0x51 , 4);
}

uint8_t dof6_get_int_low_en()
{
 return get_bit(  0x51 , 3);
}


void dof6_set_int_low_en( _Bool  set)
{
 if (set) set_bit( 0x51 , 3);
 else clear_bit ( 0x51 , 3);
}

uint8_t dof6_get_int_highz_en()
{
 return get_bit(  0x51 , 2);
}


void dof6_set_int_highz_en( _Bool  set)
{
 if (set) set_bit( 0x51 , 2);
 else clear_bit ( 0x51 , 2);
}

uint8_t dof6_get_int_highy_en()
{
 return get_bit(  0x51 , 1);
}


void dof6_set_int_highy_en( _Bool  set)
{
 if (set) set_bit( 0x51 , 1);
 else clear_bit ( 0x51 , 1);
}


uint8_t dof6_get_int_highx_en()
{
 return get_bit(  0x51 , 0);
}


void dof6_set_int_highx_en( _Bool  set)
{
 if (set) set_bit( 0x51 , 0);
 else clear_bit ( 0x51 , 0);
}



uint8_t dof6_get_int_step_det_en()
{
 return get_bit(  0x52 , 3);
}


void dof6_set_int_step_det_en( _Bool  set)
{
 if (set) set_bit( 0x52 , 3);
 else clear_bit ( 0x52 , 3);
}

uint8_t dof6_get_int_nomoz_en()
{
 return get_bit(  0x52 , 2);
}


void dof6_set_int_nomoz_en( _Bool  set)
{
 if (set) set_bit( 0x52 , 2);
 else clear_bit ( 0x52 , 2);
}

uint8_t dof6_get_int_nomoy_en()
{
 return get_bit(  0x52 , 1);
}


void dof6_set_int_nomoy_en( _Bool  set)
{
 if (set) set_bit( 0x52 , 1);
 else clear_bit ( 0x52 , 1);
}

uint8_t dof6_get_int_nomox_en()
{
 return get_bit(  0x52 , 0);
}


void dof6_set_int_nomox_en( _Bool  set)
{
 if (set) set_bit( 0x52 , 0);
 else clear_bit ( 0x52 , 0);
}



uint8_t dof6_get_int2_output_en()
{
 return get_bit( 0x53 , 7);
}


void dof6_set_int2_output_en( _Bool  set)
{
 if (set) set_bit(  0x53 , 7);
 else clear_bit (  0x53 , 7);
}

uint8_t dof6_get_int2_od()
{
 return get_bit(  0x53 , 6);
}


void dof6_set_int2_od( _Bool  set)
{
 if (set) set_bit(  0x53 , 6);
 else clear_bit (  0x53 , 6);
}

uint8_t dof6_get_int2_lvl()
{
 return get_bit(  0x53 , 5);
}


void dof6_set_int2_lvl( _Bool  set)
{
 if (set) set_bit(  0x53 , 5);
 else clear_bit (  0x53 , 5);
}

uint8_t dof6_get_int2_edge_crtl()
{
 return get_bit(  0x53 , 4);
}


void dof6_set_int2_edge_crtl( _Bool  set)
{
 if (set) set_bit(  0x53 , 4);
 else clear_bit (  0x53 , 4);
}

uint8_t dof6_get_int1_output_en()
{
 return get_bit( 0x53 , 3);
}


void dof6_set_int1_output_en( _Bool  set)
{
 if (set) set_bit(  0x53 , 3);
 else clear_bit (  0x53 , 3);
}

uint8_t dof6_get_int1_od()
{
 return get_bit(  0x53 , 2);
}


void dof6_set_int1_od( _Bool  set)
{
 if (set) set_bit(  0x53 , 2);
 else clear_bit (  0x53 , 2);
}

uint8_t dof6_get_int1_lvl()
{
 return get_bit(  0x53 , 1);
}


void dof6_set_int1_lvl( _Bool  set)
{
 if (set) set_bit(  0x53 , 1);
 else clear_bit (  0x53 , 1);
}

uint8_t dof6_get_int1_edge_crtl()
{
 return get_bit(  0x53 , 0);
}


void dof6_set_int1_edge_crtl( _Bool  set)
{
 if (set) set_bit(  0x53 , 0);
 else clear_bit (  0x53 , 0);
}



uint8_t dof6_get_int2_input_en()
{
 return get_bit(  0x54 , 5);
}


void dof6_set_int2_input_en( _Bool  set)
{
 if (set) set_bit(  0x54 , 5);
 else clear_bit (  0x54 , 5);
}

uint8_t dof6_get_int1_input_en()
{
 return get_bit(  0x54 , 4);
}


void dof6_set_int1_input_en( _Bool  set)
{
 if (set) set_bit(  0x54 , 4);
 else clear_bit (  0x54 , 4);
}


float dof6_get_int_latch()
{
 uint8_t adress =  0x54 ;
 uint8_t temp;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x0F;
 if (temp == 0) return 0;
 if (temp == 0x0F) return 1;
 t = 0.3125 * pow(2, temp - 1);
 return t;
}

void dof6_set_int_latch(int_latch_interrupt_modes int_latch)
{
 uint8_t adress =  0x54 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(15) ;
 switch (int_latch)
 {

 case NON_LATCHED:
 temp |= 0;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case TEM_312_5_mis:
 temp |= 1;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case TEM_625_mis:
 temp |= 2;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case TEM_1_25_ms:
 temp |= 3;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case TEM_2_5_ms:
 temp |= 4;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case TEM_5_ms:
 temp |= 5;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case TEM_10_ms:
 temp |= 6;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case TEM_20_ms:
 temp |= 7;
 dof6_hal_write(&adress, &temp, 1);
 break;

 case TEM_40_ms:
 temp |= 8;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case TEM_80_ms:
 temp |= 9;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case TEM_160_ms:
 temp |= 10;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case TEM_320_ms:
 temp |= 11;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case TEM_640_ms:
 temp |= 12;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case TEM_1_28_s:
 temp |= 13;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case TEM_2_56_s:
 temp |= 14;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case LATCHED:
 temp |= 15;
 dof6_hal_write(&adress, &temp, 1);
 break;
 }
}



uint8_t dof6_get_int1_flat()
{
 return get_bit(  0x55 , 7);
}


void dof6_set_int1_flat( _Bool  set)
{
 if (set) set_bit(  0x55 , 7);
 else clear_bit (  0x55 , 7);

}

uint8_t dof6_get_int1_orient()
{
 return get_bit(  0x55 , 6);
}


void dof6_set_int1_orient( _Bool  set)
{
 if (set) set_bit(  0x55 , 6);
 else clear_bit (  0x55 , 6);

}
uint8_t dof6_get_int1_s_tap()
{
 return get_bit(  0x55 , 5);
}


void dof6_set_int1_s_tap( _Bool  set)
{
 if (set) set_bit(  0x55 , 5);
 else clear_bit (  0x55 , 5);

}
uint8_t dof6_get_int1_d_tap()
{
 return get_bit(  0x55 , 4);
}


void dof6_set_int1_d_tap( _Bool  set)
{
 if (set) set_bit(  0x55 , 4);
 else clear_bit (  0x55 , 4);

}
uint8_t dof6_get_int1_nomotion()
{
 return get_bit(  0x55 , 3);
}


void dof6_set_int1_nomotion( _Bool  set)
{
 if (set) set_bit(  0x55 , 3);
 else clear_bit (  0x55 , 3);

}
uint8_t dof6_get_int1_anymotion()
{
 return get_bit(  0x55 , 2);
}


void dof6_set_int1_anymotion( _Bool  set)
{
 if (set) set_bit(  0x55 , 2);
 else clear_bit (  0x55 , 2);

}
uint8_t dof6_get_int1_highg()
{
 return get_bit(  0x55 , 1);
}


void dof6_set_int1_highg( _Bool  set)
{
 if (set) set_bit(  0x55 , 1);
 else clear_bit (  0x55 , 1);

}

uint8_t dof6_get_int1_lowg_step()
{
 return get_bit(  0x55 , 0);
}


void dof6_set_int1_lowg_step( _Bool  set)
{
 if (set) set_bit(  0x55 , 0);
 else clear_bit (  0x55 , 0);

}



uint8_t dof6_get_int1_drdy()
{
 return get_bit(  0x56 , 7);
}


void dof6_set_int1_drdy( _Bool  set)
{
 if (set) set_bit(  0x56 , 7);
 else clear_bit (  0x56 , 7);

}

uint8_t dof6_get_int1_fwm()
{
 return get_bit(  0x56 , 6);
}


void dof6_set_int1_fwm( _Bool  set)
{
 if (set) set_bit(  0x56 , 6);
 else clear_bit (  0x56 , 6);

}
uint8_t dof6_get_int1_ffull()
{
 return get_bit(  0x56 , 5);
}


void dof6_set_int1_ffull( _Bool  set)
{
 if (set) set_bit(  0x56 , 5);
 else clear_bit (  0x56 , 5);

}
uint8_t dof6_get_int1_pmu_trig()
{
 return get_bit(  0x56 , 4);
}


void dof6_set_int1_pmu_trig( _Bool  set)
{
 if (set) set_bit(  0x56 , 4);
 else clear_bit (  0x56 , 4);

}
uint8_t dof6_get_int2_drdy()
{
 return get_bit(  0x56 , 3);
}


void dof6_set_int2_drdy( _Bool  set)
{
 if (set) set_bit(  0x56 , 3);
 else clear_bit (  0x56 , 3);

}
uint8_t dof6_get_int2_fwm()
{
 return get_bit(  0x56 , 2);
}


void dof6_set_int2_fwm( _Bool  set)
{
 if (set) set_bit(  0x56 , 2);
 else clear_bit (  0x56 , 2);

}
uint8_t dof6_get_int2_ffull()
{
 return get_bit(  0x56 , 1);
}


void dof6_set_int2_ffull( _Bool  set)
{
 if (set) set_bit(  0x56 , 1);
 else clear_bit (  0x56 , 1);

}

uint8_t dof6_get_int2_pmu_trig()
{
 return get_bit(  0x56 , 0);
}


void dof6_set_int2_pmu_trig( _Bool  set)
{
 if (set) set_bit(  0x56 , 0);
 else clear_bit (  0x56 , 0);

}



uint8_t dof6_get_int2_flat()
{
 return get_bit(  0x57 , 7);
}


void dof6_set_int2_flat( _Bool  set)
{
 if (set) set_bit(  0x57 , 7);
 else clear_bit (  0x57 , 7);

}

uint8_t dof6_get_int2_orient()
{
 return get_bit(  0x57 , 6);
}


void dof6_set_int2_orient( _Bool  set)
{
 if (set) set_bit(  0x57 , 6);
 else clear_bit (  0x57 , 6);

}

uint8_t dof6_get_int2_s_tap()
{
 return get_bit(  0x57 , 5);
}


void dof6_set_int2_s_tap( _Bool  set)
{
 if (set) set_bit(  0x57 , 5);
 else clear_bit (  0x57 , 5);

}

uint8_t dof6_get_int2_d_tap()
{
 return get_bit(  0x57 , 4);
}



void dof6_set_int2_d_tap( _Bool  set)
{
 if (set) set_bit(  0x57 , 4);
 else clear_bit (  0x57 , 4);

}

uint8_t dof6_get_int2_nomotion()
{
 return get_bit(  0x57 , 3);
}



void dof6_set_int2_nomotion( _Bool  set)
{
 if (set) set_bit(  0x57 , 3);
 else clear_bit (  0x57 , 3);

}

uint8_t dof6_get_int2_anymotion()
{
 return get_bit(  0x57 , 2);
}


void dof6_set_int2_anymotion( _Bool  set)
{
 if (set) set_bit(  0x57 , 2);
 else clear_bit (  0x57 , 2);

}

uint8_t dof6_get_int2_highg()
{
 return get_bit(  0x57 , 1);
}


void dof6_set_int2_highg( _Bool  set)
{
 if (set) set_bit(  0x57 , 1);
 else clear_bit (  0x57 , 1);

}

uint8_t dof6_get_int2_lowg_step()
{
 return get_bit(  0x57 , 0);
}


void dof6_set_int2_lowg_step( _Bool  set)
{
 if (set) set_bit(  0x57 , 0);
 else clear_bit (  0x57 , 0);

}



uint8_t dof6_get_int_low_high_src()
{
 return get_bit(  0x58 , 7);
}


void dof6_set_int_low_high_src( _Bool  set)
{
 if (set) set_bit(  0x58 , 7);
 else clear_bit (  0x58 , 7);

}

uint8_t dof6_get_int_tap_src()
{
 return get_bit(  0x58 , 3);
}


void dof6_set_int_tap_src( _Bool  set)
{
 if (set) set_bit(  0x58 , 3);
 else clear_bit (  0x58 , 3);

}



uint8_t dof6_get_int_motion_src()
{
 return get_bit(  0x59 , 7);
}


void dof6_set_int_motion_src( _Bool  set)
{
 if (set) set_bit(  0x59 , 7);
 else clear_bit (  0x59 , 7);
}



float dof6_get_int_low_dur()
{
 uint8_t adress =  0x5A ;
 uint8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 t = (temp + 1) * 2.5;
 return t;
}


uint8_t dof6_set_int_low_dur(float dur)
{
 uint8_t status = 0;
 uint8_t adress =  0x5A ;
 uint8_t temp = 0;
 if (dur < 2.5 || dur > 640) return status = -1;
 temp = (uint8_t)(dur / 2.5);
 temp = temp - 1;
 dof6_hal_write(&adress, &temp, 1);
 return status;
}



float dof6_get_int_low_th()
{
 uint8_t adress =  0x5B ;
 uint8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 if (temp == 0) return 3.91;
 t = temp * 7.81;
 return t;
}


uint8_t dof6_set_int_low_th(float th)
{
 uint8_t status = 0;
 uint8_t adress =  0x5B ;
 uint8_t temp = 0;
 if (th < 3.91 || th > 2000) return status = -1;
 if (th == 3.91) dof6_hal_write(&adress, &temp, 1);
 else {
 temp = (uint8_t)(th / 7.81);
 dof6_hal_write(&adress, &temp, 1);
 }
 return status;
}




float dof6_get_int_highhy(uint8_t a)
{
 uint8_t adress =  0x5C ;
 uint8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0xC0;
 temp = temp >> 6;
 t = temp * 125 * a;
 return t;

}

float dof6_get_int_high_hy()
{
 if (dof6_get_acc_g_range() == 2 ) return dof6_get_int_highhy(1);
 if (dof6_get_acc_g_range() == 4 ) return dof6_get_int_highhy(2);
 if (dof6_get_acc_g_range() == 8 ) return dof6_get_int_highhy(4);
 if (dof6_get_acc_g_range() == 16 ) return dof6_get_int_highhy(8);


}


void dof6_set_int_highhy(float hy, uint8_t a)
{
 uint8_t adress =  0x5C ;
 uint8_t temp = 0;
 uint8_t t;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0xC0);
 t = (uint8_t)(hy / (125 * a));
 temp |= (t << 6);
 dof6_hal_write(&adress, &temp, 1);
}

uint8_t dof6_set_int_high_hy(float hy)
{
 uint8_t status = 0;
 if (dof6_get_acc_g_range() == 2 )
 {
 if ( hy < 0 || hy > 375) return status = -1;
 dof6_set_int_highhy(hy, 1);
 }
 if (dof6_get_acc_g_range() == 4 )
 {
 if ( hy < 0 || hy > 750) return status = -1;
 dof6_set_int_highhy(hy, 2);
 }
 if (dof6_get_acc_g_range() == 8 )
 {
 if ( hy < 0 || hy > 1500) return status = -1;
 dof6_set_int_highhy(hy, 4);
 }
 if (dof6_get_acc_g_range() == 16 )
 {
 if ( hy < 0 || hy > 3000) return status = -1;
 dof6_set_int_highhy(hy, 8);
 }
 return status;
}

uint8_t dof6_get_int_low_mode()
{
 return get_bit(  0x5C , 2);
}


void dof6_set_int_low_mode( _Bool  set)
{
 if (set) set_bit(  0x5C , 2);
 else clear_bit (  0x5C , 2);

}


float dof6_get_int_low_hy()
{
 uint8_t adress =  0x5C ;
 uint8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x03;
 t = temp * 125;
 return t;
}

uint8_t dof6_set_int_low_hy(float hy)
{
 uint8_t adress =  0x5C ;
 uint8_t status = 0;
 uint8_t temp = 0;
 uint8_t t;
 if ( hy < 0 || hy > 375) return status = -1;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x03);
 t = (uint8_t)(hy / 125);
 temp |= t;
 dof6_hal_write(&adress, &temp, 1);
 return status;
}



float dof6_get_int_high_dur()
{
 uint8_t adress =  0x5D ;
 uint8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 t = (temp + 1) * 2.5;
 return t;
}

uint8_t dof6_set_int_high_dur(float dur)
{
 uint8_t status = 0;
 uint8_t adress =  0x5D ;
 uint8_t temp = 0;
 uint8_t t;
 if (dur < 2.5 || dur > 650) return status = -1;
 t = (uint8_t)(dur / 2.5);
 temp = t - 1;
 dof6_hal_write(&adress, &temp, 1);
 return status;
}



float dof6_get_int_high_t(float a, float b)
{
 uint8_t adress =  0x5E ;
 uint8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 if (temp == 0) return b;
 t = temp * a;
 return t;
}

float dof6_get_int_high_th()
{
 if (dof6_get_acc_g_range() == 2 ) return dof6_get_int_high_t(7.81, 3.91);
 if (dof6_get_acc_g_range() == 4 ) return dof6_get_int_high_t(15.63, 7.81);
 if (dof6_get_acc_g_range() == 8 ) return dof6_get_int_high_t(31.25, 15.63);
 if (dof6_get_acc_g_range() == 16 ) return dof6_get_int_high_t(62.5, 31.25);
}

void dof6_set_int_high_t(float dur, float a, float b)
{
 uint8_t adress =  0x5E ;
 uint8_t temp = 0;
 if (dur == b) dof6_hal_write(&adress, &temp, 1);
 else
 {
 temp = (uint8_t)(dur / a);
 dof6_hal_write(&adress, &temp, 1);
 }
}

uint8_t dof6_set_int_high_th(float dur)
{
 uint8_t status = 0;
 if (dof6_get_acc_g_range() == 2 )
 {
 if (dur < 3.91 || dur > 1991.55) return status = -1;
 dof6_set_int_high_t(dur, 7.81, 3.91);
 }
 if (dof6_get_acc_g_range() == 4 )
 {
 if (dur < 7.81 || dur > 3985.65) return status = -1;
 dof6_set_int_high_t(dur, 15.63, 7.81);
 }
 if (dof6_get_acc_g_range() == 8 )
 {
 if (dur < 15.63 || dur > 7968.75) return status = -1;
 dof6_set_int_high_t(dur, 31.25, 15.63);
 }
 if (dof6_get_acc_g_range() == 16 )
 {
 if (dur < 31.25 || dur > 15937.5) return status = -1;
 dof6_set_int_high_t(dur, 62.5, 31.25);
 }
 return status;
}



float dof6_get_int_slo_nomo_dur()
{
 uint8_t adress =  0x5F ;
 uint8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 if (dof6_get_int_slo_nomo_sel() == 1)
 {
 temp = temp >> 6;
 if (temp == 0)
 {
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 2;
 temp &= 0x0F;
 t = (temp + 1) * 1.28;
 return t;
 }
 else if (temp == 1)
 {
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 2;
 temp &= 0x0F;
 t = (temp + 1) * 5.12;
 return t;
 }
 else if (temp == 2 || temp == 3)
 {
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 2;
 temp &= 0x1F;
 t = (temp + 11) * 10.24;
 return t;
 }
 }
 else
 {
 temp = temp >> 2;
 temp &= 0x03;
 temp += 1;
 return temp;
 }
}

int8_t dof6_set_int_slo_nomo_dur(float dur)
{
 uint8_t adress =  0x5F ;
 uint8_t temp = 0;
 uint8_t status = 0;
 uint8_t t = 0;
 dof6_hal_read(&adress, &temp, 1);
 if (dof6_get_int_slo_nomo_sel() == 1)
 {
 if (dur > 1.28 && dur < 20.48 )
 {
 t = (uint8_t)(dur / 1.28 - 1);
 temp &= ~(0x3C);
 temp |= (t << 2);
 dof6_hal_write(&adress, &temp, 1);
 return status;
 }
 if (dur > 25.6 && dur < 102.4)
 {
 t = (uint8_t)(dur / 5.12 - 5);
 temp &= ~(0x3C);
 temp |= (t << 2);
 dof6_hal_write(&adress, &temp, 1);
 return status;
 }
 if (dur > 112.64 && dur < 430.08 )
 {
 t = (uint8_t)(dur / 10.24 - 11);
 temp &= ~(0x7C);
 temp |= (t << 2);
 dof6_hal_write(&adress, &temp, 1);
 return status;
 }
 return status = -1 ;
 }
 else
 {
 if (dur > 4 && dur < 1) return status = -1;
 temp &= ~(0x0C);
 dur -= 1;
 t = (uint8_t) dur;
 t = t << 2;
 temp |= t;
 dof6_hal_write(&adress, &temp, 1);
 return status;
 }
}

uint8_t dof6_get_int_anym_dur()
{
 uint8_t adress =  0x5F ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x03;
 temp = temp + 1;
 return temp;
}


int8_t dof6_set_int_anym_dur(uint8_t dur)
{
 uint8_t status = 0;
 uint8_t adress =  0x5F ;
 uint8_t temp = 0;
 if (dur < 1 || dur > 4) return status = -1;
 dur -= 1;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x03);
 temp |= dur;
 dof6_hal_write(&adress, &temp, 1);
 return status;
}



float dof6_get_int_anymo_t(float a, float b)
{
 uint8_t adress =  0x60 ;
 uint8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 if (temp == 0) return b;
 t = temp * a;
 return t;
}

float dof6_get_int_anymo_th()
{
 if (dof6_get_acc_g_range() == 2 ) return dof6_get_int_anymo_t(3.91, 1.95);
 if (dof6_get_acc_g_range() == 4 ) return dof6_get_int_anymo_t(7.81, 3.91);
 if (dof6_get_acc_g_range() == 8 ) return dof6_get_int_anymo_t(15.63, 7.81);
 if (dof6_get_acc_g_range() == 16 ) return dof6_get_int_anymo_t(31.25, 15.63);
}

void dof6_set_int_anymo_t(float th, float a, float b)
{
 uint8_t adress =  0x60 ;
 uint8_t temp = 0;
 if (th == b) dof6_hal_write(&adress, &temp, 1);
 else {
 temp = (uint8_t)(th / a);
 dof6_hal_write(&adress, &temp, 1);
 }
}

uint8_t dof6_set_int_anymo_th(float th)
{
 uint8_t status = 0;
 if (dof6_get_acc_g_range() == 2 )
 {
 if (th < 1.95 || th > 997.05) return status = -1;
 dof6_set_int_anymo_t(th, 3.91, 1.95);
 }
 if (dof6_get_acc_g_range() == 4 )
 {
 if (th < 3.91 || th > 1991.55) return status = -1;
 dof6_set_int_anymo_t(th, 7.81, 3.91);
 }
 if (dof6_get_acc_g_range() == 8 )
 {
 if (th < 7.81 || th > 3985.65) return status = -1;
 dof6_set_int_anymo_t(th, 15.63, 7.81);
 }
 if (dof6_get_acc_g_range() == 16 )
 {
 if (th < 15.63 || th > 7968.75) return status = -1;
 dof6_set_int_anymo_t(th, 31.25, 15.63);
 }
 return status;
}





float dof6_get_int_slo_nomo_t(float a, float b)
{
 uint8_t adress =  0x61 ;
 uint8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 if (temp == 0) return b;
 t = temp * a;
 return t;
}

float dof6_get_int_slo_nomo_th()
{
 if (dof6_get_acc_g_range() == 2 ) return dof6_get_int_slo_nomo_t(3.91, 1.95);
 if (dof6_get_acc_g_range() == 4 ) return dof6_get_int_slo_nomo_t(7.81, 3.91);
 if (dof6_get_acc_g_range() == 8 ) return dof6_get_int_slo_nomo_t(15.63, 7.81);
 if (dof6_get_acc_g_range() == 16 ) return dof6_get_int_slo_nomo_t(31.25, 15.63);
}

void dof6_set_int_slo_nomo_t(float th, float a, float b)
{
 uint8_t adress =  0x61 ;
 uint8_t temp = 0;
 if (th == b) dof6_hal_write(&adress, &temp, 1);
 else
 {
 temp = (uint8_t)(th / a);
 dof6_hal_write(&adress, &temp, 1);
 }
}

uint8_t dof6_set_int_slo_nomo_th(float th)
{
 uint8_t status = 0;
 if (dof6_get_acc_g_range() == 2 )
 {
 if (th < 1.95 || th > 997.05) return status = -1;
 dof6_set_int_slo_nomo_t(th, 3.91, 1.95);
 }
 if (dof6_get_acc_g_range() == 4 )
 {
 if (th < 3.91 || th > 1991.55) return status = -1;
 dof6_set_int_slo_nomo_t(th, 7.81, 3.91);
 }
 if (dof6_get_acc_g_range() == 8 )
 {
 if (th < 7.81 || th > 3985.65) return status = -1;
 dof6_set_int_slo_nomo_t(th, 15.63, 7.81);
 }
 if (dof6_get_acc_g_range() == 16 )
 {
 if (th < 15.63 || th > 7968.75) return status = -1;
 dof6_set_int_slo_nomo_t(th, 31.25, 15.63);
 }
 return status;
}



uint8_t dof6_get_int_slo_nomo_sel()
{
 return get_bit(  0x62  , 0);
}


void dof6_set_int_slo_nomo_sel( _Bool  set)
{
 if (set) set_bit(  0x62  , 0);
 else clear_bit (  0x62  , 0);

}

uint8_t dof6_get_int_sig_mot_sel()
{
 return get_bit(  0x62  , 1);
}


void dof6_set_int_sig_mot_sel( _Bool  set)
{
 if (set) set_bit(  0x62  , 1);
 else clear_bit (  0x62  , 1);

}

float dof6_get_int_sig_mot_skip()
{
 uint8_t adress =  0x62 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 2;
 temp &= 3;
 if (temp == 0) return 1.5;
 if (temp == 1) return 3;
 if (temp == 2) return 6;
 if (temp == 3) return 12;
}


int8_t dof6_set_int_sig_mot_skip(int_sig_mot_skip time)
{
 uint8_t adress =  0x62 ;
 uint8_t temp = 0;
 uint8_t status = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x0C);
 switch (time)
 {
 case SKIP_TIME_1_5_s :
 dof6_hal_write(&adress, &temp, 1);
 break;
 case SKIP_TIME_3_s :
 temp |= 0x04;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case SKIP_TIME_6_s :
 temp |= 0x08;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case SKIP_TIME_12_s :
 temp |= 0x0C;
 dof6_hal_write(&adress, &temp, 1);
 break;
 default:
 status = -1;
 break;
 }
 return status;

}

float dof6_get_int_sig_mot_proof()
{
 uint8_t adress =  0x62 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 4;
 temp &= 3;
 if (temp == 0) return 0.25;
 if (temp == 1) return 0.5;
 if (temp == 2) return 1;
 if (temp == 3) return 2;
}


int8_t dof6_set_int_sig_mot_proof(int_sig_mot_skip time)
{
 uint8_t adress =  0x62 ;
 uint8_t temp = 0;
 uint8_t status = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x30);
 switch (time)
 {
 case PROOF_TIME_0_25_s :
 dof6_hal_write(&adress, &temp, 1);
 break;
 case PROOF_TIME_0_5_s :
 temp |= 0x10;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case PROOF_TIME_1_s :
 temp |= 0x20;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case PROOF_TIME_2_s :
 temp |= 0x30;
 dof6_hal_write(&adress, &temp, 1);
 break;
 default:
 status = -1;
 break;
 }
 return status;

}




uint8_t dof6_get_int_tap_quiet()
{
 return get_bit(  0x63  , 7);
}


void dof6_set_int_tap_quiet( _Bool  set)
{
 if (set) set_bit(  0x63  , 7);
 else clear_bit ( 0x63  , 7);

}

uint8_t dof6_get_int_tap_shock()
{
 return get_bit(  0x63  , 6);
}


void dof6_set_int_tap_shock( _Bool  set)
{
 if (set) set_bit(  0x63  , 6);
 else clear_bit (  0x63  , 6);

}

uint16_t dof6_get_int_tap_dur()
{
 uint8_t adress =  0x63 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 7;
 if (temp == 0) return 50;
 if (temp == 1) return 100;
 if (temp == 2) return 150;
 if (temp == 3) return 200;
 if (temp == 4) return 250;
 if (temp == 5) return 375;
 if (temp == 6) return 500;
 if (temp == 7) return 700;
}


int8_t dof6_set_int_tap_dur(int_tap_dur time)
{
 uint8_t adress =  0x63 ;
 uint8_t temp = 0;
 uint8_t status = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x07);
 switch (time)
 {
 case SECOND_SHOCK_EVENT_50_s :
 dof6_hal_write(&adress, &temp, 1);
 break;
 case SECOND_SHOCK_EVENT_100_s :
 temp |= 1;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case SECOND_SHOCK_EVENT_150_s :
 temp |= 2;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case SECOND_SHOCK_EVENT_200_s :
 temp |= 3;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case SECOND_SHOCK_EVENT_250_s :
 temp |= 4;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case SECOND_SHOCK_EVENT_375_s :
 temp |= 5;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case SECOND_SHOCK_EVENT_500_s :
 temp |= 6;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case SECOND_SHOCK_EVENT_700_s :
 temp |= 7;
 dof6_hal_write(&adress, &temp, 1);
 break;
 default:
 status = -1;
 break;
 }
 return status;

}


float dof6_get_int_tap_t(float a)
{
 uint8_t adress =  0x64 ;
 uint8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x0F;
 if (temp == 0) return a / 2;
 t = temp * a;
 return t;
}

float dof6_get_int_tap_th()
{
 if (dof6_get_acc_g_range() == 2 ) return dof6_get_int_tap_t(62.5);
 if (dof6_get_acc_g_range() == 4 ) return dof6_get_int_tap_t(125);
 if (dof6_get_acc_g_range() == 8 ) return dof6_get_int_tap_t(250);
 if (dof6_get_acc_g_range() == 16 ) return dof6_get_int_tap_t(500);
}

void dof6_set_int_tap_t(float th, float a)
{
 uint8_t adress =  0x64 ;
 uint8_t temp = 0;
 uint8_t t;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x0F);
 if (th == a / 2) dof6_hal_write(&adress, &temp, 1);
 else
 {
 t = (uint8_t)(th / a);
 temp |= t;
 dof6_hal_write(&adress, &temp, 1);
 }
}

uint8_t dof6_set_int_tap_th(float th)
{
 uint8_t status = 0;
 if (dof6_get_acc_g_range() == 2 )
 {
 if (th < 31.25 || th > 1937.5) return status = -1;
 dof6_set_int_tap_t(th, 62.5);
 }
 if (dof6_get_acc_g_range() == 4 )
 {
 if (th < 62.5 || th > 3875) return status = -1;
 dof6_set_int_tap_t(th, 125);
 }
 if (dof6_get_acc_g_range() == 8 )
 {
 if (th < 125 || th > 7750) return status = -1;
 dof6_set_int_tap_t(th, 250);
 }
 if (dof6_get_acc_g_range() == 16 )
 {
 if (th < 250 || th > 15500) return status = -1;
 dof6_set_int_tap_t(th, 500);
 }
 return status;
}





float dof6_get_int_orient_hy()
{
 uint8_t adress =  0x65 ;
 uint8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 4;
 temp &= 0x0F;
 t = temp * 62.5;
 return t;
}


uint8_t dof6_set_int_orient_hy(float th)
{
 uint8_t adress =  0x65 ;
 uint8_t temp = 0;
 uint8_t t = 0;
 uint8_t status = 0;
 if (th < 0 || th > 1937.5) return status = -1;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0xF0);
 t = (uint8_t)(th / 62.5);
 temp |= (t << 4);
 dof6_hal_write(&adress, &temp, 1);
 return status;
}


uint8_t dof6_get_int_orient_blocking()
{
 uint8_t adress =  0x65 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 2;
 temp &= 3;
 return temp;
}


int8_t dof6_set_int_orient_blocking(uint8_t block)
{
 uint8_t adress =  0x65 ;
 uint8_t temp = 0;
 uint8_t status = 0;
 dof6_hal_read(&adress, &temp, 1);
 if (block < 0 || block > 3) return status = -1;
 temp &= ~(0x0C);
 temp |= (block << 2);
 dof6_hal_write(&adress, &temp, 1);
 return status;
}

uint8_t dof6_get_int_orient_mode()
{
 uint8_t adress =  0x65 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 3;
 return temp;
}


int8_t dof6_set_int_orient_mode(int_orient_mode mode)
{
 uint8_t adress =  0x65 ;
 uint8_t temp = 0;
 uint8_t status = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x03);
 switch (mode)
 {
 case SYMMETRICAL :
 dof6_hal_write(&adress, &temp, 1);
 break;
 case HIGH_SYMMETRICAL :
 temp |= 1;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case LOW_ASYMMETRICAL :
 temp |= 2;
 dof6_hal_write(&adress, &temp, 1);
 break;
 default:
 status = -1;
 break;
 }
 return status;
}



uint8_t dof6_get_int_orient_axes_ex()
{
 return get_bit(  0x66  , 7);
}


void dof6_set_int_orient_axes_ex( _Bool  set)
{
 if (set) set_bit(  0x66  , 7);
 else clear_bit ( 0x66  , 7);

}

uint8_t dof6_get_int_orient_ud_en()
{
 return get_bit(  0x66  , 6);
}


void dof6_set_int_orient_ud_en( _Bool  set)
{
 if (set) set_bit(  0x66  , 6);
 else clear_bit (  0x66  , 6);

}


float dof6_get_int_orient_theta()
{
 uint8_t adress =  0x66 ;
 uint8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x3F;
 t = 0.7 * temp;
 return t;
}

int8_t dof6_set_int_orient_theta(float angle)
{
 uint8_t adress =  0x66 ;
 uint8_t temp = 0;
 uint8_t t;
 uint8_t status = 0;
 dof6_hal_read(&adress, &temp, 1);
 if (angle < 0 || angle > 44.8) return status = -1;
 t = (uint8_t) (angle / 0.7);
 temp &= ~(0x3F);
 temp |= t;
 dof6_hal_write(&adress, &temp, 1);
 return status;
}



float dof6_get_int_flat_theta()
{
 uint8_t adress =  0x67 ;
 uint8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x3F;
 t = 0.7 * temp;
 return t;
}

int8_t dof6_set_int_flat_theta(float flat_angle)
{
 uint8_t adress =  0x67 ;
 uint8_t temp = 0;
 uint8_t status = 0;
 uint8_t tem;
 dof6_hal_read(&adress, &temp, 1);
 if (flat_angle < 0 || flat_angle > 44.8) return status = -1;
 tem = (uint8_t)(flat_angle / 0.7);
 temp &= ~(0x3F);
 temp |= tem;
 dof6_hal_write(&adress, &temp, 1);
 return status;
}


uint16_t dof6_get_int_flat_hold_time()
{
 uint8_t adress =  0x68 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 4;
 temp &= 3;
 if (temp == 0) return 0;
 if (temp == 1) return 640;
 if (temp == 2) return 1280;
 if (temp == 3) return 2560;

}


int8_t dof6_set_int_flat_hold_time(int_flat_hold_time time)
{
 uint8_t adress =  0x68 ;
 uint8_t temp = 0;
 uint8_t status = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x30);
 switch (time)
 {
 case FLAT_STABLE_0_ms :
 dof6_hal_write(&adress, &temp, 1);
 break;
 case FLAT_STABLE_640_ms :
 temp |= 0x10;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case FLAT_STABLE_1280_ms :
 temp |= 0x20;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case FLAT_STABLE_2560_ms :
 temp |= 0x30;
 dof6_hal_write(&adress, &temp, 1);
 break;
 default:
 status = -1;
 break;
 }
 return status;
}


uint8_t dof6_get_int_flat_hy()
{
 uint8_t adress =  0x68 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 0x07;
 return temp;
}

int8_t dof6_set_int_flat_hy(uint8_t flat_hy)
{
 uint8_t adress =  0x68 ;
 uint8_t temp = 0;
 uint8_t status = 0;
 dof6_hal_read(&adress, &temp, 1);
 if (flat_hy < 0 || flat_hy > 7) return status = -1;
 temp &= ~(0x07);
 temp |= flat_hy;
 dof6_hal_write(&adress, &temp, 1);
 return status;
}



uint8_t dof6_get_foc_gyr_en()
{
 return get_bit(  0x69  , 6);
}


void dof6_set_foc_gyr_en( _Bool  set)
{
 if (set) set_bit(  0x69  , 6);
 else clear_bit ( 0x69  , 6);

}


int8_t dof6_get_foc_acc_x()
{
 uint8_t adress =  0x69 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 4;
 temp &= 3;
 if (temp == 0) return -2;
 if (temp == 1) return 1;
 if (temp == 2) return -1;
 if (temp == 3) return 0;

}

int8_t dof6_set_foc_acc_x(foc_acc_x offset)
{
 uint8_t adress =  0x69 ;
 uint8_t temp = 0;
 uint8_t status = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x30);
 switch (offset)
 {
 case X_DISABLED :
 dof6_hal_write(&adress, &temp, 1);
 break;
 case X_1_g :
 temp |= 0x10;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case X_minus_1_g :
 temp |= 0x20;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case X_0_g :
 temp |= 0x30;
 dof6_hal_write(&adress, &temp, 1);
 break;
 default:
 status = -1;
 break;
 }

 return status;
}

int8_t dof6_get_foc_acc_y()
{
 uint8_t adress =  0x69 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 2;
 temp &= 3;
 if (temp == 0) return -2;
 if (temp == 1) return 1;
 if (temp == 2) return -1;
 if (temp == 3) return 0;

}

int8_t dof6_set_foc_acc_y(foc_acc_y offset)
{
 uint8_t adress =  0x69 ;
 uint8_t temp = 0;
 uint8_t status = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x0C);
 switch (offset)
 {
 case Y_DISABLED :
 dof6_hal_write(&adress, &temp, 1);
 break;
 case Y_1_g :
 temp |= 0x04;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case Y_minus_1_g :
 temp |= 0x08;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case Y_0_g :
 temp |= 0x0C;
 dof6_hal_write(&adress, &temp, 1);
 break;
 default:
 status = -1;
 break;
 }
 return status;
}

int8_t dof6_get_foc_acc_z()
{
 uint8_t adress =  0x69 ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 3;
 if (temp == 0) return -2;
 if (temp == 1) return 1;
 if (temp == 2) return -1;
 if (temp == 3) return 0;

}

int8_t dof6_set_foc_acc_z(foc_acc_y offset)
{
 uint8_t adress =  0x69 ;
 uint8_t temp = 0;
 uint8_t status = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x03);
 switch (offset)
 {
 case Z_DISABLED :
 dof6_hal_write(&adress, &temp, 1);
 break;
 case Z_1_g :
 temp |= 0x01;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case Z_minus_1_g :
 temp |= 0x02;
 dof6_hal_write(&adress, &temp, 1);
 break;
 case Z_0_g :
 temp |= 0x03;
 dof6_hal_write(&adress, &temp, 1);
 break;
 default:
 status = -1;
 break;
 }
 return status;
}



uint8_t dof6_get_nvm_prog_en()
{
 return get_bit( 0x6A  , 1);
}


void dof6_set_nvm_prog_en( _Bool  set)
{
 if (set) set_bit(  0x6A  , 1);
 else clear_bit ( 0x6A  , 1);

}



uint8_t dof6_get_spi3()
{
 return get_bit( 0x6B  , 1);
}


void dof6_set_spi3( _Bool  set)
{
 if (set) set_bit( 0x6B  , 1);
 else clear_bit ( 0x6B  , 1);

}

uint8_t dof6_get_if_mode()
{
 uint8_t adress =  0x6B ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 4;
 temp &= 3;
 return temp;

}

int8_t dof6_set_if_mode(uint8_t if_mode)
{
 uint8_t adress =  0x6B ;
 uint8_t temp = 0;
 uint8_t status = 0;
 if (if_mode < 0 || if_mode > 3) return status = -1;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x30);
 temp |= (if_mode << 4);
 dof6_hal_write(&adress, &temp, 1);
 return status;
}



uint8_t dof6_get_wakeup_int()
{
 return get_bit( 0x6C  , 6);
}


void dof6_set_wakeup_int( _Bool  set)
{
 if (set) set_bit( 0x6C  , 6);
 else clear_bit ( 0x6C  , 6);

}

uint8_t dof6_get_gyr_sleep_state()
{
 return get_bit( 0x6C  , 5);
}


void dof6_set_gyr_sleep_state( _Bool  set)
{
 if (set) set_bit( 0x6C  , 5);
 else clear_bit ( 0x6C  , 5);

}

uint8_t dof6_get_gyr_wakeup_trigg()
{
 uint8_t adress =  0x6C ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 3;
 temp &= 3;
 return temp;
}

int8_t dof6_set_gyr_wakeup_trigg(uint8_t gyr_wakeup)
{
 uint8_t adress =  0x6C ;
 uint8_t temp = 0;
 uint8_t status = 0;
 if (gyr_wakeup < 0 || gyr_wakeup > 3) return status = -1;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x18);
 temp |= (gyr_wakeup << 3);
 dof6_hal_write(&adress, &temp, 1);
 return status;
}


uint8_t dof6_get_gyr_sleep_trigger()
{
 uint8_t adress =  0x6C ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 7;
 return temp;
}

int8_t dof6_set_gyr_sleep_trigger(uint8_t gyr_sleep)
{
 uint8_t adress =  0x6C ;
 uint8_t temp = 0;
 uint8_t status = 0;
 if (gyr_sleep < 0 || gyr_sleep > 7) return status = -1;
 dof6_hal_read(&adress, &temp, 1);
 temp &= ~(0x07);
 temp |= gyr_sleep;
 dof6_hal_write(&adress, &temp, 1);
 return status;
}



uint8_t dof6_get_gyr_self_test_enable()
{
 return get_bit( 0x6D  , 4);
}


void dof6_set_gyr_self_test_enable( _Bool  set)
{
 if (set) set_bit( 0x6D  , 4);
 else clear_bit ( 0x6D  , 4);

}

uint8_t dof6_get_acc_self_test_amp()
{
 return get_bit( 0x6D  , 3);
}


void dof6_set_acc_self_test_amp( _Bool  set)
{
 if (set) set_bit( 0x6D  , 3);
 else clear_bit ( 0x6D  , 3);

}

uint8_t dof6_get_acc_self_test_sign()
{
 return get_bit( 0x6D  , 2);
}


void dof6_set_acc_self_test_sign( _Bool  set)
{
 if (set) set_bit( 0x6D  , 2);
 else clear_bit ( 0x6D  , 2);

}

uint8_t dof6_get_acc_self_test_enable()
{
 uint8_t adress =  0x6D ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 3;
 return temp;
}

void dof6_set_acc_self_test_enable( _Bool  set)
{
 uint8_t adress =  0x6D ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 if (set)
 {
 temp |= 1;
 dof6_hal_write(&adress, &temp, 1);
 }
 else dof6_hal_write(&adress, &temp, 1);
}



uint8_t dof6_get_i2c_wdt_en()
{
 return get_bit( 0x70  , 2);
}


void dof6_set_i2c_wdt_en( _Bool  set)
{
 if (set) set_bit( 0x70  , 2);
 else clear_bit ( 0x70  , 2);

}

uint8_t dof6_get_i2c_wdt_sel()
{
 return get_bit( 0x70  , 1);
}


void dof6_set_i2c_wdt_sel( _Bool  set)
{
 if (set) set_bit( 0x70  , 1);
 else clear_bit ( 0x70  , 1);

}

uint8_t dof6_get_spi_en()
{
 return get_bit( 0x70  , 0);
}


void dof6_set_spi_en( _Bool  set)
{
 if (set) set_bit( 0x70  , 0);
 else clear_bit ( 0x70  , 0);

}



float dof6_get_off_acc_x()
{
 uint8_t adress =  0x71 ;
 int8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 t = temp * 3.9;
 return t;

}

uint8_t dof6_set_off_acc_x(float offset)
{
 uint8_t adress =  0x71 ;
 int8_t temp;
 uint8_t status = 0;
 if (offset < -495.3 || offset > 495.3) return status = -1;
 temp = (int8_t) (offset / 3.9);
 dof6_hal_write(&adress, &temp, 1);
 return status;
}



float dof6_get_off_acc_y()
{
 uint8_t adress =  0x72 ;
 int8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 t = temp * 3.9;
 return t;
}

uint8_t dof6_set_off_acc_y(float offset)
{
 uint8_t adress =  0x72 ;
 int8_t temp;
 uint8_t status = 0;
 if (offset < -495.3 || offset > 495.3) return status = -1;
 temp = (int8_t) (offset / 3.9);
 dof6_hal_write(&adress, &temp, 1);
 return status;
}



float dof6_get_off_acc_z()
{
 uint8_t adress =  0x73 ;
 uint8_t temp = 0;
 float t;
 dof6_hal_read(&adress, &temp, 1);
 t = temp * 3.9;
 return t;
}

uint8_t dof6_set_off_acc_z(float offset)
{
 uint8_t adress =  0x73 ;
 uint8_t temp;
 uint8_t status = 0;
 if (offset < -495.3 || offset > 495.3) return status = -1;
 temp = (uint8_t) (offset / 3.9);
 dof6_hal_write(&adress, &temp, 1);
 return status;
}



float dof6_get_off_gyr_x()
{
 uint8_t adress1 =  0x74 ;
 uint8_t adress2 =  0x77 ;
 int8_t temp1 = 0;
 int8_t temp2 = 0;
 int16_t temp = 0;
 float t;
 dof6_hal_read(&adress1, &temp1, 1);
 dof6_hal_read(&adress2, &temp2, 1);
 temp2 &= 3;
 temp += temp1;
 temp |= (temp2 << 8);
 if (temp2 == 3 || temp2 == 2)
 {
 temp = ~(temp) + 1;
 temp &= 1023;
 temp = -temp;
 }
 t = temp * 0.061;
 return t;
}

uint8_t dof6_set_off_gyr_x(float offset)
{
 uint8_t adress1 =  0x74 ;
 uint8_t adress2 =  0x77 ;
 int16_t temp;
 int8_t temp1;
 int8_t temp2;
 int8_t t;
 uint8_t status = 0;
 if (offset < -31.25 || offset > 31.25) return status = -1;
 temp = (int16_t) (offset / 0.061);
 temp1 = (int8_t) temp;
 temp2 = (int8_t) (temp >> 8);
 dof6_hal_write(&adress1, &temp1, 1);
 dof6_hal_read(&adress2, &t, 1);
 t &= ~(0x03);
 t |= temp2;
 dof6_hal_write(&adress2, &t, 1);
 return status;
}



float dof6_get_off_gyr_y()
{
 uint8_t adress1 =  0x74 ;
 uint8_t adress2 =  0x77 ;
 int8_t temp1 = 0;
 int8_t temp2 = 0;
 int16_t temp = 0;
 float t;
 dof6_hal_read(&adress1, &temp1, 1);
 dof6_hal_read(&adress2, &temp2, 1);
 temp2 &= 12;
 temp2 = temp2 >> 2;
 temp += temp1;
 temp |= (temp2 << 8);
 if (temp2 == 3 || temp2 == 2)
 {
 temp = ~(temp) + 1;
 temp &= 1023;
 temp = -temp;
 }
 t = temp * 0.061;
 return t;
}

uint8_t dof6_set_off_gyr_y(float offset)
{
 uint8_t adress1 =  0x74 ;
 uint8_t adress2 =  0x77 ;
 int16_t temp;
 int8_t temp1;
 int8_t temp2;
 int8_t t;
 uint8_t status = 0;
 if (offset < -31.25 || offset > 31.25) return status = -1;
 temp = (int16_t) (offset / 0.061);
 temp1 = (int8_t) temp;
 temp2 = (int8_t) (temp >> 8);
 dof6_hal_write(&adress1, &temp1, 1);
 dof6_hal_read(&adress2, &t, 1);
 t &= ~(0x0C);
 t |= (temp2 << 2);
 dof6_hal_write(&adress2, &t, 1);
 return status;
}



float dof6_get_off_gyr_z()
{
 uint8_t adress1 =  0x74 ;
 uint8_t adress2 =  0x77 ;
 int8_t temp1 = 0;
 int8_t temp2 = 0;
 int16_t temp = 0;
 float t;
 dof6_hal_read(&adress1, &temp1, 1);
 dof6_hal_read(&adress2, &temp2, 1);
 temp2 &= 0x30;
 temp2 = temp2 >> 4;
 temp += temp1;
 temp |= (temp2 << 8);
 if (temp2 == 3 || temp2 == 2)
 {
 temp = ~(temp) + 1;
 temp &= 1023;
 temp = -temp;
 }
 t = temp * 0.061;
 return t;
}

uint8_t dof6_set_off_gyr_z(float offset)
{
 uint8_t adress1 =  0x74 ;
 uint8_t adress2 =  0x77 ;
 int16_t temp;
 int8_t temp1;
 int8_t temp2;
 int8_t t;
 uint8_t status = 0;
 if (offset < -31.25 || offset > 31.25) return status = -1;
 temp = (int16_t) (offset / 0.061);
 temp1 = (int8_t) temp;
 temp2 = (int8_t) (temp >> 8);
 dof6_hal_write(&adress1, &temp1, 1);
 dof6_hal_read(&adress2, &t, 1);
 t &= ~(0x30);
 t |= (temp2 << 4);
 dof6_hal_write(&adress2, &t, 1);
 return status;
}



uint8_t dof6_get_gyr_off_en()
{
 return get_bit( 0x77  , 7);
}


void dof6_set_gyr_off_en( _Bool  set)
{
 if (set) set_bit( 0x77  , 7);
 else clear_bit ( 0x77  , 7);

}

uint8_t dof6_get_acc_off_en()
{
 return get_bit( 0x77  , 6);
}


void dof6_set_acc_off_en( _Bool  set)
{
 if (set) set_bit( 0x77  , 6);
 else clear_bit ( 0x77  , 6);

}





uint16_t dof6_get_step_cnt()
{
 return get_unsinged_data( 0x78 );
}



uint8_t dof6_get_min_threshold()
{
 uint8_t adress =  0x7A ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp = temp >> 3;
 temp &= 3;
 return temp;
}

int8_t dof6_set_min_threshold(uint8_t min_th)
{
 uint8_t adress =  0x7A ;
 uint8_t temp;
 uint8_t status = 0;
 dof6_hal_read(&adress, &temp, 1);
 if (min_th < 0 || min_th > 3) return status = -1;
 temp &= ~(0x18);
 temp |= (min_th << 3);
 dof6_hal_write(&adress, &temp, 1);
 return status;
}

uint8_t dof6_get_steptime_min()
{
 uint8_t adress =  0x7A ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 7;
 return temp;
}

int8_t dof6_set_steptime_min(uint8_t steptime)
{
 uint8_t adress =  0x7A ;
 uint8_t temp;
 uint8_t status = 0;
 dof6_hal_read(&adress, &temp, 1);
 if (steptime < 0 || steptime > 7) return status = -1;
 temp &= ~(0x07);
 temp |= steptime;
 dof6_hal_write(&adress, &temp, 1);
 return status;
}



uint8_t dof6_get_step_cnt_en()
{
 return get_bit( 0x7B  , 3);
}


void dof6_set_step_cnt_en( _Bool  set)
{
 if (set) set_bit( 0x7B  , 3);
 else clear_bit ( 0x7B  , 3);

}

uint8_t dof6_get_min_step_buf()
{
 uint8_t adress =  0x7B ;
 uint8_t temp = 0;
 dof6_hal_read(&adress, &temp, 1);
 temp &= 7;
 return temp;
}

int8_t dof6_set_min_step_buf(uint8_t steptime)
{
 uint8_t adress =  0x7B ;
 uint8_t temp;
 uint8_t status = 0;
 dof6_hal_read(&adress, &temp, 1);
 if (steptime < 0 || steptime > 7) return status = -1;
 temp &= ~(0x07);
 temp |= steptime;
 dof6_hal_write(&adress, &temp, 1);
 return status;
}



void dof6_sensor_config (uint8_t accel_state, uint8_t gyro_state)
{
 uint8_t temp= 0x7E ;
 uint8_t temp_data1 = accel_state;
 uint8_t temp_data2 = gyro_state;
 dof6_hal_write( &temp,&temp_data1,1 );
 delay_ms(100);
 dof6_hal_write( &temp,&temp_data2,1 );
 delay_ms(100);
}

uint8_t dof6_get_cmd()
{
 uint8_t adress =  0x7E ;
 uint8_t temp;
 dof6_hal_read(&adress, &temp, 1);
 return temp;
}


uint8_t dof6_set_cmd(uint8_t cmd)
{
 uint8_t status = 0;
 uint8_t adress =  0x7E ;
 uint8_t temp = cmd;
 if (cmd > 255) return status = -1;
 dof6_hal_write(&adress, &temp, 1);
 return status;
}
