_Auxiliary_Code:
LDA.x	R0, #AlignedAddress(GPIO_PIN47_bit+0)
BINS.L	R0, R0, #BitPos(GPIO_PIN47_bit+0)=0
STI.x	GPIO_PIN47_bit+0, #AlignedAddress(R0)
NOP	
LDA.x	R0, #AlignedAddress(GPIO_PIN47_bit+0)
BINS.L	R0, R0, #BitPos(GPIO_PIN47_bit+0)=1
STI.x	GPIO_PIN47_bit+0, #AlignedAddress(R0)
L_end_Auxiliary_Code:
RETURN	
; end of _Auxiliary_Code
_Set_Index:
; index start address is: 0 (R0)
; index end address is: 0 (R0)
; index start address is: 0 (R0)
LDA.x	R1, #AlignedAddress(GPIO_PIN40_bit+0)
BINS.L	R1, R1, #BitPos(GPIO_PIN40_bit+0)=0
STI.x	GPIO_PIN40_bit+0, #AlignedAddress(R1)
NOP	
STA.B	GPIO_PORT_32_39+0, R0
; index end address is: 0 (R0)
NOP	
NOP	
CALL	_Auxiliary_Code+0
L_end_Set_Index:
RETURN	
; end of _Set_Index
_Write_Command:
; cmd start address is: 0 (R0)
; cmd end address is: 0 (R0)
; cmd start address is: 0 (R0)
LDA.x	R1, #AlignedAddress(GPIO_PIN40_bit+0)
BINS.L	R1, R1, #BitPos(GPIO_PIN40_bit+0)=1
STI.x	GPIO_PIN40_bit+0, #AlignedAddress(R1)
NOP	
STA.B	GPIO_PORT_32_39+0, R0
; cmd end address is: 0 (R0)
NOP	
NOP	
CALL	_Auxiliary_Code+0
L_end_Write_Command:
RETURN	
; end of _Write_Command
_Write_Data:
LINK	LR, #4
STI.S	SP, #0, R0
LDA.x	R1, #AlignedAddress(GPIO_PIN40_bit+0)
BINS.L	R1, R1, #BitPos(GPIO_PIN40_bit+0)=1
STI.x	GPIO_PIN40_bit+0, #AlignedAddress(R1)
NOP	
ADD.L	R1, SP, #0
ADD.L	R1, R1, #1
LDI.B	R1, R1, #0
STA.B	GPIO_PORT_32_39+0, R1
NOP	
NOP	
CALL	_Auxiliary_Code+0
NOP	
ADD.L	R1, SP, #0
LDI.B	R1, R1, #0
STA.B	GPIO_PORT_32_39+0, R1
NOP	
NOP	
CALL	_Auxiliary_Code+0
L_end_Write_Data:
UNLINK	LR
RETURN	
; end of _Write_Data
6dof_imu2_click_Display_Init:
LDK.L	R2, #_Write_Data+0
LDK.L	R1, #_Write_Command+0
LDK.L	R0, #_Set_Index+0
CALL	_TFT_Set_Active+0
LDK.L	R1, #240
LDK.L	R0, #320
CALL	_TFT_Init_ILI9341_8bit+0
LDA.x	R0, #AlignedAddress(GPIO_PIN58_bit+0)
BINS.L	R0, R0, #BitPos(GPIO_PIN58_bit+0)=1
STI.x	GPIO_PIN58_bit+0, #AlignedAddress(R0)
LDK.L	R0, #65535
CALL	_TFT_Fill_Screen+0
LDK.L	R1, #1
LDK.L	R0, #0
CALL	_TFT_Set_Pen+0
LDK.L	R3, #220
LDK.L	R2, #300
LDK.L	R1, #220
LDK.L	R0, #20
CALL	_TFT_Line+0
LDK.L	R3, #46
LDK.L	R2, #300
LDK.L	R1, #46
LDK.L	R0, #20
CALL	_TFT_Line+0
LDK.L	R2, #0
LDK.L	R1, #63488
LDK.L	R0, #_HandelGothic_BT21x22_Regular+0
CALL	_TFT_Set_Font+0
LDK.L	R0, #?lstr1_6dof_imu2_click+0
LDK.L	R2, #14
LDK.L	R1, #20
CALL	_TFT_Write_Text+0
LDK.L	R2, #0
LDK.L	R1, #63488
LDK.L	R0, #_Verdana12x13_Regular+0
CALL	_TFT_Set_Font+0
LDK.L	R0, #?lstr2_6dof_imu2_click+0
LDK.L	R2, #223
LDK.L	R1, #19
CALL	_TFT_Write_Text+0
LDK.L	R2, #0
LDK.L	R1, #63488
LDK.L	R0, #_Verdana12x13_Regular+0
CALL	_TFT_Set_Font+0
LDK.L	R0, #?lstr3_6dof_imu2_click+0
LDK.L	R2, #223
LDK.L	R1, #200
CALL	_TFT_Write_Text+0
LDK.L	R1, #1
LDK.L	R0, #65535
CALL	_TFT_Set_Pen+0
LDK.L	R5, #0
LDK.L	R4, #0
LDK.L	R3, #0
LDK.L	R2, #0
LDK.L	R1, #65535
LDK.L	R0, #1
CALL	_TFT_Set_Brush+0
LDK.L	R2, #0
LDK.L	R1, #0
LDK.L	R0, #_TFT_defaultFont+0
CALL	_TFT_Set_Font+0
LDK.L	R0, #?lstr4_6dof_imu2_click+0
LDK.L	R2, #60
LDK.L	R1, #30
CALL	_TFT_Write_Text+0
LDK.L	R0, #?lstr5_6dof_imu2_click+0
LDK.L	R2, #120
LDK.L	R1, #30
CALL	_TFT_Write_Text+0
LDK.L	R0, #?lstr6_6dof_imu2_click+0
LDK.L	R2, #180
LDK.L	R1, #30
CALL	_TFT_Write_Text+0
LDK.L	R0, #?lstr7_6dof_imu2_click+0
LDK.L	R2, #60
LDK.L	R1, #210
CALL	_TFT_Write_Text+0
LDK.L	R0, #?lstr8_6dof_imu2_click+0
LDK.L	R2, #120
LDK.L	R1, #210
CALL	_TFT_Write_Text+0
LDK.L	R0, #?lstr9_6dof_imu2_click+0
LDK.L	R2, #180
LDK.L	R1, #210
CALL	_TFT_Write_Text+0
L_end_Display_Init:
RETURN	
; end of 6dof_imu2_click_Display_Init
_display_data:
CALL	_dof6_get_acc_x+0
STA.L	_acc_x+0, R0
CALL	_dof6_get_acc_y+0
STA.L	_acc_y+0, R0
CALL	_dof6_get_acc_z+0
STA.L	_acc_z+0, R0
CALL	_dof6_get_gyr_x+0
STA.L	_gyro_x+0, R0
CALL	_dof6_get_gyr_y+0
STA.L	_gyro_y+0, R0
CALL	_dof6_get_gyr_z+0
STA.L	_gyro_z+0, R0
LDA.L	R2, _acc_x+0
LDK.L	R1, #?lstr_10_6dof_imu2_click+0
LDK.L	R0, #_txt1+0
PUSH.L	R2
PUSH.L	R1
PUSH.L	R0
CALL	_sprintf+0
ADD.L	SP, SP, #12
LDK.L	R3, #100
LDK.L	R2, #80
LDK.L	R1, #80
LDK.L	R0, #30
CALL	_TFT_Rectangle+0
LDK.L	R2, #80
LDK.L	R1, #30
LDK.L	R0, #_txt1+0
CALL	_TFT_Write_Text+0
LDA.L	R2, _acc_y+0
LDK.L	R1, #?lstr_11_6dof_imu2_click+0
LDK.L	R0, #_txt1+0
PUSH.L	R2
PUSH.L	R1
PUSH.L	R0
CALL	_sprintf+0
ADD.L	SP, SP, #12
LDK.L	R3, #160
LDK.L	R2, #80
LDK.L	R1, #140
LDK.L	R0, #30
CALL	_TFT_Rectangle+0
LDK.L	R2, #140
LDK.L	R1, #30
LDK.L	R0, #_txt1+0
CALL	_TFT_Write_Text+0
LDA.L	R2, _acc_z+0
LDK.L	R1, #?lstr_12_6dof_imu2_click+0
LDK.L	R0, #_txt1+0
PUSH.L	R2
PUSH.L	R1
PUSH.L	R0
CALL	_sprintf+0
ADD.L	SP, SP, #12
LDK.L	R3, #210
LDK.L	R2, #80
LDK.L	R1, #200
LDK.L	R0, #30
CALL	_TFT_Rectangle+0
LDK.L	R2, #200
LDK.L	R1, #30
LDK.L	R0, #_txt1+0
CALL	_TFT_Write_Text+0
LDA.L	R2, _gyro_x+0
LDK.L	R1, #?lstr_13_6dof_imu2_click+0
LDK.L	R0, #_txt1+0
PUSH.L	R2
PUSH.L	R1
PUSH.L	R0
CALL	_sprintf+0
ADD.L	SP, SP, #12
LDK.L	R3, #100
LDK.L	R2, #260
LDK.L	R1, #80
LDK.L	R0, #210
CALL	_TFT_Rectangle+0
LDK.L	R2, #80
LDK.L	R1, #210
LDK.L	R0, #_txt1+0
CALL	_TFT_Write_Text+0
LDA.L	R2, _gyro_y+0
LDK.L	R1, #?lstr_14_6dof_imu2_click+0
LDK.L	R0, #_txt1+0
PUSH.L	R2
PUSH.L	R1
PUSH.L	R0
CALL	_sprintf+0
ADD.L	SP, SP, #12
LDK.L	R3, #160
LDK.L	R2, #260
LDK.L	R1, #140
LDK.L	R0, #210
CALL	_TFT_Rectangle+0
LDK.L	R2, #140
LDK.L	R1, #210
LDK.L	R0, #_txt1+0
CALL	_TFT_Write_Text+0
LDA.L	R2, _gyro_z+0
LDK.L	R1, #?lstr_15_6dof_imu2_click+0
LDK.L	R0, #_txt1+0
PUSH.L	R2
PUSH.L	R1
PUSH.L	R0
CALL	_sprintf+0
ADD.L	SP, SP, #12
LDK.L	R3, #210
LDK.L	R2, #260
LDK.L	R1, #200
LDK.L	R0, #210
CALL	_TFT_Rectangle+0
LDK.L	R2, #200
LDK.L	R1, #210
LDK.L	R0, #_txt1+0
CALL	_TFT_Write_Text+0
L_end_display_data:
RETURN	
; end of _display_data
_main:
LDK.L	SP, #43605
CALL	6dof_imu2_click_Display_Init+0
LDK.L	R1, #0
LDK.L	R0, #0
CALL	_I2CM1_Init+0
LDK.L	R0, #104
CALL	_dof6_hal_init+0
LDK.L	R1, #21
LDK.L	R0, #17
CALL	_dof6_sensor_config+0
L_main0:
CALL	_display_data+0
LPM.L	R28, #1666665
NOP	
L_main2:
SUB.L	R28, R28, #1
CMP.L	R28, #0
JMPC	R30, Z, #0, L_main2
JMP	$+8
	#1666665
JMP	L_main0
L_end_main:
L__main_end_loop:
JMP	L__main_end_loop
; end of _main
