#line 1 "C:/Users/Viktor/Desktop/6dof_imu2/FT90/6dof_hal.c"
#line 1 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hal.h"
#line 1 "c:/users/viktor/desktop/new_compiler/mikroc pro for ft90x/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 73 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hal.h"
void dof6_hal_init( uint8_t address_id );
#line 85 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hal.h"
void dof6_hal_write( uint8_t *command,
 uint8_t *buffer,
 uint8_t count );
#line 98 "c:/users/viktor/desktop/6dof_imu2/ft90/6dof_hal.h"
void dof6_hal_read( uint8_t *command,
 uint8_t *buffer,
 uint8_t count );
#line 1 "c:/users/viktor/desktop/new_compiler/mikroc pro for ft90x/include/stdint.h"
#line 22 "C:/Users/Viktor/Desktop/6dof_imu2/FT90/6dof_hal.c"
static uint8_t _i2c_hw_address;
#line 89 "C:/Users/Viktor/Desktop/6dof_imu2/FT90/6dof_hal.c"
static void( *soft_reset_i2c_p )( void );
static void( *set_slave_address_i2c_p )( unsigned char slave_address );
static unsigned char( *write_i2c_p )( unsigned char data_out );
static unsigned char( *read_i2c_p )( unsigned char *data_in );
static unsigned char( *write_bytes_i2c_p )( unsigned char *buffer,
 unsigned int count );
static unsigned char( *read_bytes_i2c_p )( unsigned char *buffer,
 unsigned int count );
static unsigned char( *write_10bit_i2c_p )( unsigned char data_out,
 unsigned int address_10bit );
static unsigned char( *read_10bit_i2c_p )( unsigned char *data_in,
 unsigned int address_10bit );
#line 113 "C:/Users/Viktor/Desktop/6dof_imu2/FT90/6dof_hal.c"
void dof6_hal_init ( uint8_t address_id )
{
#line 181 "C:/Users/Viktor/Desktop/6dof_imu2/FT90/6dof_hal.c"
 soft_reset_i2c_p = I2CM_Soft_Reset_Ptr;
 set_slave_address_i2c_p = I2CM_Set_Slave_Address_Ptr;
 write_i2c_p = I2CM_Write_Ptr;
 read_i2c_p = I2CM_Read_Ptr;
 write_bytes_i2c_p = I2CM_Write_Bytes_Ptr;
 read_bytes_i2c_p = I2CM_Read_Bytes_Ptr;
 write_10bit_i2c_p = I2CM_Write_10Bit_Ptr;
 read_10bit_i2c_p = I2CM_Read_10Bit_Ptr;
#line 194 "C:/Users/Viktor/Desktop/6dof_imu2/FT90/6dof_hal.c"
 _i2c_hw_address = address_id;
#line 198 "C:/Users/Viktor/Desktop/6dof_imu2/FT90/6dof_hal.c"
}

void dof6_hal_write( uint8_t *command,
 uint8_t *buffer,
 uint8_t count )
{
 uint8_t temp[  256  ];
 uint8_t cmd_size =  1 ;
 uint16_t i = 0;
 uint8_t c=0;

 while( cmd_size-- )
 temp[ i++ ] = *( command++ );

 while ( count-- )
 temp[ i++ ] = *( buffer++ );
#line 240 "C:/Users/Viktor/Desktop/6dof_imu2/FT90/6dof_hal.c"
 set_slave_address_i2c_p( _i2c_hw_address );
 write_bytes_i2c_p( temp, i );
#line 258 "C:/Users/Viktor/Desktop/6dof_imu2/FT90/6dof_hal.c"
}

void dof6_hal_read( uint8_t *command,
 uint8_t *buffer,
 uint8_t count )
{
 uint8_t cmd_size =  1 ;
#line 312 "C:/Users/Viktor/Desktop/6dof_imu2/FT90/6dof_hal.c"
 set_slave_address_i2c_p( _i2c_hw_address );

 if ( cmd_size == 1 )
 write_i2c_p( *command );
 else
 write_bytes_i2c_p( command, cmd_size );

 read_bytes_i2c_p( buffer, count );
#line 375 "C:/Users/Viktor/Desktop/6dof_imu2/FT90/6dof_hal.c"
}
